# ess.tcl---ESS card setup

#   July 7 2000  first version for testing prototype cards   VP

set debug 0
set started 0

set frame ESS
set frametitle "ESS Card setup"
set icontitle ESS

set chanlist {???}
set chanindex 0

set defaultchanlist {0 1 2 3 4 5 6 7}
set cardtype ESS
set VXIGlobal ""
global chansel chanlist chanindex
#    The array "table" which is indexed by the "widget name" contains all the information needed
#    for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for register access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"


set table(CHANNEL) {channel widget->channel channel->widget nil
        nil nil nil nil nil nil nil 1 nil}
set table(ALLCHANS) {allchans int-widget->param param->int-widget nil nil nil nil nil nil nil nil 0 nil}
set table(ENABLE) {enable int-widget->param param->int-widget "CCR.Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Module Enable"}

set table(ADDRE) {addre widget->param param->hex-widget "Energy.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Energy Address"}
set table(RDE) {rde int-widget->param param->int-widget "Energy.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Energy Readout Enable"}

set table(ADDRP) {addrp widget->param param->hex-widget "Pattern.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Pattern Address"}
set table(RDP) {rdp int-widget->param param->int-widget "Pattern.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Pattern Readout Enable"}

set table(ADDRT) {addrt widget->param param->hex-widget "TDC.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "TDC Address"}
set table(RDT) {rdt int-widget->param param->int-widget "TDC.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TDC Readout Enable"}

set table(ADDRTA) {addrta widget->param param->hex-widget "TDC.QA.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "TDC QA Address"}
set table(RDTA) {rdta int-widget->param param->int-widget "TDC.QA.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TDC QA Readout Enable"}

set table(ADDRTB) {addrtb widget->param param->hex-widget "TDC.QB.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "TDC QB Address"}
set table(RDTB) {rdtb int-widget->param param->int-widget "TDC.QB.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TDC QB Readout Enable"}

set table(ADDRTC) {addrtc widget->param param->hex-widget "TDC.QC.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "TDC QC Address"}
set table(RDTC) {rdtc int-widget->param param->int-widget "TDC.QC.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TDC QC Readout Enable"}

set table(ADDRTD) {addrtd widget->param param->hex-widget "TDC.QD.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "TDC QD Address"}
set table(RDTD) {rdtd int-widget->param param->int-widget "TDC.QD.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TDC QD Readout Enable"}

set table(FTSAMPLE) {ftsample slider-widget->param param->int-widget "LT.FTSample"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "LT FT Sample"}
set table(VALSAMPLE) {valsample slider-widget->param param->int-widget "LT.ValSample"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "LT Val Sample"}
set table(WATCHDOG) {watchdog slider-widget->param param->int-widget "LT.Watchdog"
       unit-reg->param param->unit-reg us :slider 0 255 1 1 "LT Watchdog"}

set table(LTMODE) {ltmode int-widget->param param->int-widget "CCR.LTStartMode" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "LT Mode"}
set table(SSMODE) {ssmode int-widget->param param->int-widget "CCR.SSControl" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "SS Control"}

set table(TDCSEL) {tdcsel int-widget->param param->int-widget "TDC.StopSelect" 
       int-reg->param param->int-reg nil :choice-stack nil nil nil 1 "TDC Select"}
set table(TQASTOP) {tqastop int-widget->param param->int-widget "TDC.QA.StopSelect" 
       int-reg->param param->int-reg nil :choice-stack nil nil nil 1 "TDC QA Stop"}
set table(TQBSTOP) {tqbstop int-widget->param param->int-widget "TDC.QB.StopSelect" 
       int-reg->param param->int-reg nil :choice-stack nil nil nil 1 "TDC QB Stop"}
set table(TQCSTOP) {tqcstop int-widget->param param->int-widget "TDC.QC.StopSelect" 
       int-reg->param param->int-reg nil :choice-stack nil nil nil 1 "TDC QC Stop"}
set table(TQDSTOP) {tqdstop int-widget->param param->int-widget "TDC.QD.StopSelect" 
       int-reg->param param->int-reg nil :choice-stack nil nil nil 1 "TDC QD Stop"}

set table(VETODELAY) {vetodelay slider-widget->param param->int-widget "VetoDelay"
       unit-reg->param param->unit-reg ns :slider 0 150 1 1 "Veto Delay"}
set table(VETOWIDTH) {vetowidth slider-widget->param param->int-widget "VetoWidth"
       unit-reg->param param->unit-reg ns :slider 0 2550 1 1 "Veto Width"}
set table(PATTERNWIDTH) {patternwidth slider-widget->param param->int-widget "PatternWidth"
       unit-reg->param param->unit-reg ns :slider 0 2550 1 1 "Pattern Width"}

set table(MODELCODE) {modcode str-widget->param param->hex-widget "VXI.ModelCode" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(SERIALNUM) {serialnum str-widget->param param->hex-widget "VXI.SerialNum" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(MODLEVEL) {modlevel str-widget->param param->hex-widget "VXI.ModLevel" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(MANID) {manid str-widget->param param->hex-widget "VXI.ManID" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(OFFSET) {offset str-widget->param param->hex-widget "VXI.Offset" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}

set table(DSPDACADJ) {dspdacadj widget->param param->hex-widget "DSP.DAC.Adj"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "DSP DAC Adjust"}
set table(DSPPOTADJ) {dsppotadj widget->param param->hex-widget "DSP.POT.Adj"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "DSP POT Adjust"}

set table(ALIGNBGOQA) {alignbgoqa slider-widget->param param->int-widget "BGO.QA.AlignDelay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "BGO QA Alignment"}
set table(ALIGNBGOQB) {alignbgoqb slider-widget->param param->int-widget "BGO.QB.AlignDelay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "BGO QB Alignment"}
set table(ALIGNBGOQC) {alignbgoqc slider-widget->param param->int-widget "BGO.QC.AlignDelay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "BGO QC Alignment"}
set table(ALIGNBGOQD) {alignbgoqd slider-widget->param param->int-widget "BGO.QD.AlignDelay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "BGO QD Alignment"}

set table(ALIGNCSIQA) {aligncsiqa slider-widget->param param->int-widget "CSI.QA.AlignDelay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "CsI QA Alignment"}
set table(ALIGNCSIQB) {aligncsiqb slider-widget->param param->int-widget "CSI.QB.AlignDelay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "CsI QB Alignment"}
set table(ALIGNCSIQC) {aligncsiqc slider-widget->param param->int-widget "CSI.QC.AlignDelay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "CsI QC Alignment"}
set table(ALIGNCSIQD) {aligncsiqd slider-widget->param param->int-widget "CSI.QD.AlignDelay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "CsI QD Alignment"}

set table(ALIGNGEQA) {aligngeqa slider-widget->param param->int-widget "Ge.QA.AlignDelay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "Ge QA Alignment"}
set table(ALIGNGEQB) {aligngeqb slider-widget->param param->int-widget "Ge.QB.AlignDelay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "Ge QB Alignment"}
set table(ALIGNGEQC) {aligngeqc slider-widget->param param->int-widget "Ge.QC.AlignDelay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "Ge QC Alignment"}
set table(ALIGNGEQD) {aligngeqd slider-widget->param param->int-widget "Ge.QD.AlignDelay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "Ge QD Alignment"}

set table(THRESBGOQA) {thresbgoqa slider-widget->param param->int-widget "BGO.QA.Thresh"
       unit-reg->param param->unit-reg KeV :slider 0 255 1 1 "BGO QA Threshold"}
set table(THRESBGOQB) {thresbgoqb slider-widget->param param->int-widget "BGO.QB.Thresh"
       unit-reg->param param->unit-reg KeV :slider 0 255 1 1 "BGO QB Threshold"}
set table(THRESBGOQC) {thresbgoqc slider-widget->param param->int-widget "BGO.QC.Thresh"
       unit-reg->param param->unit-reg KeV :slider 0 255 1 1 "BGO QC Threshold"}
set table(THRESBGOQD) {thresbgoqd slider-widget->param param->int-widget "BGO.QD.Thresh"
       unit-reg->param param->unit-reg KeV :slider 0 255 1 1 "BGO QD Threshold"}

set table(THRESCSIQA) {threscsiqa slider-widget->param param->int-widget "CSI.QA.Thresh"
       unit-reg->param param->unit-reg KeV :slider 0 255 1 1 "CSI QA Threshold"}
set table(THRESCSIQB) {threscsiqb slider-widget->param param->int-widget "CSI.QB.Thresh"
       unit-reg->param param->unit-reg KeV :slider 0 255 1 1 "CSI QB Threshold"}
set table(THRESCSIQC) {threscsiqc slider-widget->param param->int-widget "CSI.QC.Thresh"
       unit-reg->param param->unit-reg KeV :slider 0 255 1 1 "CSI QC Threshold"}
set table(THRESCSIQD) {threscsiqd slider-widget->param param->int-widget "CSI.QD.Thresh"
       unit-reg->param param->unit-reg KeV :slider 0 255 1 1 "CSI QD Threshold"}

set table(ESSMCRFIFORESET) {essmcrfiforeset  logic-widget->param param->logic-widget "ESS.FIFO.Reset"
                     not-reg->param param->not-reg "" nil nil nil nil 0 nil}

#    load default GIR support before GIR table items - the defaults may be redefined
loadsource gir

set table(GIREVNUMADDR)    {girevnumaddr     int-widget->param param->hex-widget "GIR.EvNum.Addr"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIREVNUMCOUNT)    {girevnumcount   int-widget->param param->hex-widget "GIR.EvNum.Count"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRMCRLASTCARD)  {girmcrlastcard   logic-widget->param param->logic-widget "LastCard"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRMCRFIFORESET) {girmcrfiforeset  logic-widget->param param->logic-widget "FIFO.Reset"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRMCRDSPRESET)  {girmcrdspreset   logic-widget->param param->logic-widget "DSP.Reset"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRMCRGIRRESET)  {girmcrgirreset   logic-widget->param param->logic-widget "ResetGIR"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRMCRPROMWP)  {girmcrpromwp   logic-widget->param param->logic-widget "PROM.WP"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRDCR0)  {girdcr0   logic-widget->param param->logic-widget "GIR.DCR.DataXfer1.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCR1)  {girdcr1   logic-widget->param param->logic-widget "GIR.DCR.DataXfer2.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCR2)  {girdcr2   logic-widget->param param->logic-widget "GIR.DCR.DSP_Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCR3)  {girdcr3   logic-widget->param param->logic-widget "GIR.DCR.DMA_TEST"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRROCRVALACKTIMEOUTRESET) {girrocrvalacktimeoutreset logic-widget->param param->logic-widget "GIR.RCR.ValAck.TimeOutReset"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRREADOUTDISABLE)     {girreadoutdisable     logic-widget->param param->logic-widget "GIR.RCR.ReadOut.Disable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCREVNUMDATADISABLE) {girevnumdatadisable logic-widget->param param->logic-widget "GIR.RCR.EvNumData.Disable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCREVNUMQBITSENABLE) {girevnumqbitsenable logic-widget->param param->logic-widget "GIR.RCR.EvNumQbits.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRPIPELINEENABLE) {girpipelineenable logic-widget->param param->logic-widget "GIR.RCR.PipeLine.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRCDTENABLE) {gircdtenable logic-widget->param param->logic-widget "GIR.RCR.CommonDeadTime.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCREXTENABLE) {girextenable logic-widget->param param->logic-widget "GIR.RCR.ExtReadout.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRPARILTEST) {girparilenable logic-widget->param param->logic-widget "GIR.RCR.TestParil.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRROTSRTEMPSTATUS)    {girrotsrtempstatus    int-widget->param param->hex-widget "GIR.ROTSR.Temp.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRFIFOSTATUS)    {girrotsrfifostatus    int-widget->param param->hex-widget "GIR.ROTSR.FIFO.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRVALACKTIMEOUTSTATUS) {girrotsrvalacktimeoutstatus  logic-widget->param param->logic-widget "GIR.ROTSR.ValAck.TimeOut.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRVALACKTIMEOUT)    {girvalacktimeout    slider-widget->param param->int-widget "GIR.ValAck.TimeOut"
                     unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}



#    register selection for parameter save function
set registersavepatterns {
  CCR DSP.DAC.Adj DSP.POT.Adj DSP.DCR GIR.RCR GIR.ValAck.TimeOut 
  *.ROEnable BGO.*.Thresh CSI.*.Thresh BGO.*.AlignDelay CSI.*.AlignDelay Ge.*.AlignDelay
  LT.FTSample LT.ValSample LT.Watchdog
  TDC.StopSelect TDC.*.StopSelect TDC.Select
  VetoDelay VetoWidth PatternWidth
}

# inspection tables must be in same order as entries in the :choice-stacks
# this is achieved by using these tables when generating the choices
# index number returned maps directly to the signal number to be written to 
# the Signal Select register

set insp_table(MUX-AI1) {"Insp.A1" AI}
set insp_table(MUX-AI2) {"Insp.A2" AI}
set insp_table(MUX-DI1) {"Insp.D1" DI}
set insp_table(MUX-DI2) {"Insp.D2" DI}
set insp_table(MUX-VI)  {"Insp.V"  VI}

set insp_menu(MUX-AI1) analogueinsptable
set insp_menu(MUX-AI2) analogueinsptable
set insp_menu(MUX-DI1) digitalinsptable
set insp_menu(MUX-DI2) digitalinsptable
#set insp_menu(MUX-VI) voltageinsptable


set inspection_widgetnames {MUX-AI1 MUX-AI2 MUX-DI1 MUX-DI2 MUX-VI}
set inspection_regnames    {Insp.A1 Insp.A2 Insp.D1 Insp.D2 Insp.V}

#    the inspection line tables are in parallel
#    for channel select * implies value determined by adc channel
#    for parameter select * implies disconnect

set analogueinsptable {Disconnected
      "BGO Input QA" "BGO Input QB" "BGO Input QC" "BGO Input QD" "CsI Input QA" "CsI Input QB" "CsI Input QC" "CsI Input QD"
      "BGO Peak" "CsI Peak" "Sum of BGO+CsI Peak" "BGO PZ test point" "CsI PZ test point"
}

set AI-ChanSelect {0 * * * * * * * * * *  *  *  *}
set AI-Param      {* 0 1 2 3 4 5 6 7 8 9 10 11 12}

set voltageinsptable {}
set VI-ChanSelect {}
set VI-Param      {}


set digitalinsptable {Disconnected
        "BGO Discr QA" "BGO Discr QB" "BGO Discr QC" "BGO Discr QD"
        "CsI Discr QA" "CsI Discr QB" "CsI Discr QC" "CsI Discr QD"
        "PDS Gate BGO" "PDS Hold/Reset BGO" "PDS Gate CsI" "PDS Hold/Reset CsI"
        "Veto QA" "Veto QB" "Veto QC" "Veto QD"
        "LT Start" "LT FT Sample" "LT Val Sample" "LT Reset Out" "LT Valack" "LT Watchdog"
        "ADC Busy" "ADC Clock" "ADC Fail" "ADC Output Enable"
        "Read TDC QA" "Read TDC QB" "Read TDC QC" "Read TDC QD"  "Read TDC" "Read Pattern"
        "Ge CFD-in QA" "Ge CFD-in QB" "Ge CFD-in QC" "Ge CFD-in QD"
        "Ge CFD-out Aligned QA" "Ge CFD-out Aligned QB" "Ge CFD-out Aligned QC" "Ge CFD-out Aligned QD"
        "BGO-out Aligned QA" "BGO-out Aligned QB" "BGO-out Aligned QC" "BGO-out Aligned QD"
        "CsI-out Aligned QA" "CsI-out Aligned QB" "CsI-out Aligned QC" "CsI-out Aligned QD"
        "TDC Start QA" "TDC Start QB" "TDC Start QC" "TDC Start QD"  "TDC Start"
        "TDC Stop QA" "TDC Stop QB" "TDC Stop QC" "TDC Stop QD"  "TDC Stop"
        "Any BGO" "Any CsI" "Any Ge"
        "Start Pattern" "Pattern Gate" "TDC Reset In"
        "Fast Trigger" "Validation" "Inhibit Action" "LT Reset In"
        "Readout DataReady" "Readout DataAck" "Readout Ren-IN" "Readout Last Pass"
        "16MHz SYSCLK" "33MHz CLK"
        "Fast Trigger (GIR)" "Inhibit Action" Validation "Event Reject" "Beam Pulse"
        OrValack "Conversion DeadTime" StartReadout Rdout-Renin Rdout-DTready DTready1 DTready2 DTready3
        Rdout-DTack Rdout-LastPass CLKWF WNWF
        AS*(VME) DS(VME) R/W*(VME) ModRoco CardRenin* BLTACK(Card) BLTACK(Bus) FDTDCK DTACK*(VME)
        Oe_GIRV5 CardRenout LT_Reset* ClkB-Fifo ENR-F1 Or-Fifo Reset-Fifo Sysclk
        en_DMA DMA-Req DMA-Grant Link_Start Link5_Ack Link5_Clk Link5_Dat0 Link5_Dat1 Link5_Dat2 Link5_Dat3
        OE_Link5_out OE_DSP_Run  Rdout-Evt-Fault-M1 Rdout-Evt-Fault Rdout-Evt-Match 



}

set DI-ChanSelect {0 * * * * * * * * * * * * * * * * *
                       * * * * * * * * * * * * * * * *
                       * * * * * * * * * * * * * * * *
                       * * * * * * * * * * * * * * *
                     5 5 5 5 5 5 5 5 5 5
        32 32 32 32 32
        32 32 32 32 32 32 32 32 32 32 32 32
        32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
        32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 
}

set DI-Param      {* 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16
                       17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32
                       33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48
                       49 50 51 52 53 54 55 56 57 58 59 60 61 62 63
                     0 1 2 3 4 5 6 7 8 9 
        1 2 3 4 5
        6 7 8 9 10 11 12 13 14 15 16 17
        22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38
        39 40 41 42 43 44 45 46 47 48 49 50 51 52 53
}

set tacmenu  {
    "Stop=RF Start=BGO (whole shield)"  "Stop=RF Start=CsI (whole shield)"
    "Stop=RF Start=BGO or CsI (whole shield)" "Stop=RF Start=Ge (OR of all Ge CFDs)"
    "Stop=FT Start=BGO (whole shield)"  "Stop=FT Start=CsI (whole shield)"
    "Stop=FT Start=BGO or CsI (whole shield)" "Stop=FT Start=Ge (OR of all Ge CFDs)"
    "Stop=Ge (OR of all Ge CFDs) Start=BGO (whole shield)"  "Stop=Ge (OR of all Ge CFDs) Start=CsI (whole shield)"
    "Stop=Ge (OR of all Ge CFDs) Start=BGO or CsI (whole shield)" "Stop=Ge (OR of all Ge CFDs) Start=Ge (OR of all Ge CFDs)"
}

set tacqmenu     {"BGO (nearest quadrant)" "BGO (whole shield)" "CsI (nearest quadrant)" "CsI (whole shield)" 
                  "BGO or CsI (nearest quadrant)" "BGO or CsI (whole shield)" RF FT}


loadsource common.vxi

proc click arg {
   global debug userselection allchans
   if {$debug} then {insert-debug "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]
   if {$c==":quit"} then {return [click-quit $f]}
   switch -glob $w {
      *REDISPLAY   {click-redisplay}
      ENGINEERING  {click-$v}

      CHANNEL     {click-channel $v}
      ALLCHANS    {click-whichchans $v}
      CHANSEL     {click-chanselection $v}

      GIR*        {click-GIRwindow $w $v}

      MUX-*       {click-inspection $w $i}

      default   {
          if {$allchans < 0} then {set userselection 1}
             click-on $w $v
             set userselection 0
      }
   }
}



proc make-frame1 {} {
  global env chanlist
  global analogueinsptable digitalinsptable
  global tacmenu tacqmenu

  :frame [self frame-name] :label "[self frame-title]" :show-footer T :resize F \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]"

   :panel P1 :layout T :padx 10 :pady 5
     :layout H; :row-gap 10; :col-gap 10
      :choice-stack CHANNEL :label "Current Channel:" :strings $chanlist :valuex 18c
      :hskip 80
      :checkbox ENABLE :label "Enable:"
      :next-row T
      :choice ALLCHANS :label "Act on Channels?" :valuex 18c :strings [list Current All Select] :value 0

   :panel P2 :layout T :padx 10
     :layout H; :col-gap 5;  :row-gap 5

      :message RDEM  :label "Readout Enable" :bold T
      :next-row T

      :checkbox RDE      :label "Energy"   :valuex 10c
      :checkbox RDP      :label "Pattern"  :valuex 10c
      :checkbox RDT      :label "TDC"      :valuex 10c

      :next-row T
      :checkbox RDTA     :label "TDC QA"   :valuex 10c
      :checkbox RDTB     :label "TDC QB"   :valuex 10c
      :checkbox RDTC     :label "TDC QC"   :valuex 10c
      :checkbox RDTD     :label "TDC QD"   :valuex 10c

   :panel P3 :layout T :padx 10 :pady 10
     :layout V; :row-gap 5

      :message SETUPM  :label "Channel Setup" :bold T
      :next-row T

      :slider FTSAMPLE      :label "LT FT Sample (ns):"  :min 0 :max 3200    :valuex 20c
      :slider VALSAMPLE     :label "LT Val Sample (ns):" :min 0 :max 10000   :valuex 20c
      :slider WATCHDOG      :label "LT Watchdog (us):"   :min 6 :max 64      :valuex 20c :resolution 1 :steps 58

      :choice LTMODE        :label "LT Mode"           :valuex 20c  :strings [list "Start by BGO or CSI" "Start by Ge, BGO or CSI"]
      :choice SSMODE        :label "Slide Scale Mode"  :valuex 20c  :strings [list "SS Low (=0)" "SS On" "SS Low (=0)" "SS Full"]

      :slider VETODELAY      :label "Veto Delay (nS):"    :min 0 :max 150    :valuex 20c :resolution 10
      :slider VETOWIDTH      :label "Veto Width (nS):"    :min 0 :max 2550   :valuex 20c :resolution 10
      :slider PATTERNWIDTH   :label "Pattern Width (nS):" :min 0 :max 2550   :valuex 20c :resolution 10


   :panel P6 :layout T :padx 10 :pady 10
     :layout H; :col-gap 100; :row-gap 10

      :button TIMEALIGN      :label "Time Alignment Setup"  :command start-align
      :button THRESHOLD      :label "Threshold Setup"       :command start-thres

      :next-row T
      :layout V
      :row-gap 5

      :message TDCM :label "TDC Start/Stop Mode Selection" :bold T

      :choice-stack TDCSEL    :label "TDC Stop/Start"  :strings $tacmenu  :value 11 :rows 15

      :choice-stack TQASTOP :label "TDC QA" :strings $tacqmenu :valuex 10c :value 4
      :choice-stack TQBSTOP :label "TDC QB" :strings $tacqmenu :valuex 10c :value 4
      :choice-stack TQCSTOP :label "TDC QC" :strings $tacqmenu :valuex 10c :value 4
      :choice-stack TQDSTOP :label "TDC QD" :strings $tacqmenu :valuex 10c :value 4

   :panel P4 :layout T :padx 10 :pady 10
      :layout H; :col-gap 10; :row-gap 10
      :menubutton MUX-AI1 :label "Analogue Inspection 1:" :w 22 :strings $analogueinsptable
      :message MUX-AI1-USE   :label ""
      :next-row T
      :menubutton MUX-AI2 :label "Analogue Inspection 2:" :w 22 :strings $analogueinsptable
      :message MUX-AI2-USE   :label ""
      :next-row T
      :menubutton MUX-DI1 :label "Digital Inspection 1:"  :w 22 :strings $digitalinsptable :rows 15
      :message MUX-DI1-USE   :label ""
      :next-row T
      :menubutton MUX-DI2 :label "Digital Inspection 2:"  :w 22 :strings $digitalinsptable :rows 15
      :message MUX-DI2-USE   :label ""

   :panel P5 :layout B :padx 10 :after FOOTER
     :layout H; :col-gap 10; :row-gap 5
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics software]
      GIRbutton
      :button REDISPLAY
      :hskip 60
      :button HELP  
   
 :show T
}

set electronicsframe [self frame-name].electronics

proc make-electronics {} {
  global env electronicsframe electronicsvisible

set col1 25c

  :frame "$electronicsframe" :label "ESS Electronics" :resize F :transient T

   :panel P1 :layout T :padx 5 :pady 5
      :layout V; :row-gap 5; :col-gap 5
      :message M1       :label "VXI Registers:"  :bold T 

      :text MODELCODE     :label "Model Code:"         :w 6  :read-only T   :valuex $col1
      :text SERIALNUM     :label "Serial Number:"      :w 6  :read-only T   :valuex $col1
      :text MODLEVEL      :label "Modification Level:" :w 6  :read-only T   :valuex $col1
      :text MANID         :label "Manufacturer ID:"    :w 6  :read-only T   :valuex $col1
      :text OFFSET        :label "VXI Offset:"         :w 6  :read-only T   :valuex $col1
      :vskip 20

      :checkbox ESSMCRFIFORESET  :label "ESS FIFO Reset"         :valuex $col1
   
  :show T
 set electronicsvisible 1
}

proc make-chanSELframe {} {
  global chansel chanlist

   :frame CHANSEL-FRAME :label "ESS Channel Selection"  :show-footer F :resize F :transient T
   :panel CHANSEL-PANEL :layout T
   :choice CHANSEL :exclusive F :strings $chanlist :value $chansel
   :show T
}  

proc click-GIRwindow  {w v} {click-on $w $v}

proc make-GIR {} {
  global env girvisible girframe

set col1 40c
set col2 25c

  :frame $girframe :label "ESS Card GIR" :show-footer T :resize F :transient T 

  :panel P1 :layout T :padx 5 :pady 5
    :layout V; :row-gap 5; :col-gap 5

      :message M1 :label "Module Control Register" :bold T
      :checkbox GIRMCRLASTCARD   :label "Last Card"          :valuex $col1 :deaf T
      :layout H
      :next-row T
      :checkbox GIRMCRFIFORESET  :label "FIFO Reset"         :valuex $col2
      :checkbox GIRMCRDSPRESET   :label "DSP Reset"          :valuex $col2
      :next-row T
      :checkbox GIRMCRGIRRESET   :label "GIR Reset"          :valuex $col2
      :checkbox GIRMCRPROMWP     :label "PROM Write Enable"  :valuex $col2
      :next-row T
      :layout V

      :text     GIREVNUMADDR     :label "Event Number Address:"  :valuex $col1 :w 6  :deaf T
      :text     GIREVNUMCOUNT    :label "Event Number Counter:"  :valuex $col1 :w 6  :deaf T

      :text     GIRFIFOACCESS    :label "Fifo Test Access"  :valuex $col2 :w 10 
      :layout H; :hskip 30
      :button   GIRFIFOREAD      :label "Read"
      :text     GIRFIFODATA      :label "" :w 10
      :next-row T

      :layout V
      :message M20 :label "DSP Control Register" :bold T
      :checkbox GIRDCR0   :label "Data Xfer ESS=>DSP Enable"   :valuex $col1 
      :checkbox GIRDCR1   :label "Data Xfer DSP=>VXI Enable"   :valuex $col1
      :checkbox GIRDCR2   :label "DSP Link Xfer Enable"        :valuex $col1
      :checkbox GIRDCR3   :label "DMA Test Enable"             :valuex $col1

      :message M21       :label "Common Setup:"  :bold T
      :text DSPDACADJ     :label "DSP DAC Adjustment"  :valuex $col1 :w 10
      :text DSPPOTADJ     :label "DSP Pot Adjustment"  :valuex $col1 :w 10

      :message M3 :label "Readout Control Register" :bold T
      :checkbox GIRROCRVALACKTIMEOUTRESET :label "Enable Valack Timeout Reset"           :valuex $col1
      :checkbox GIRROCRREADOUTDISABLE     :label "GIR Readout Disable:"                  :valuex $col1
      :checkbox GIRROCREVNUMDATADISABLE   :label "Event Number Readout Disable:"         :valuex $col1
      :checkbox GIRROCREVNUMQBITSENABLE   :label "Use Event Number Qbits:"               :valuex $col1
      :checkbox GIRROCRPIPELINEENABLE     :label "Pipeline readout enable:"              :valuex $col1
      :checkbox GIRROCRCDTENABLE          :label "CDT readout enable:"                   :valuex $col1
      :checkbox GIRROCREXTENABLE          :label "Ext readout enable:"                   :valuex $col1
      :checkbox GIRROCRPARILTEST          :label "Test Mode for PARIL readout:"          :valuex $col1

      :message M4 :label "Readout and Temperature Status Register"  :bold T
      :text    GIRROTSRTEMPSTATUS        :label "Temperature Sensor Status:"   :valuex $col1 :w 6 :deaf T
      :text    GIRROTSRFIFOSTATUS        :label "FIFOs Status:"                :valuex $col1 :w 6 :deaf T
      :checkbox GIRROTSRVALACKTIMEOUTSTATUS     :label "ValAck Timeout Asserted:"       :valuex $col1 :deaf T
        
      :slider  GIRVALACKTIMEOUT          :label "ValAck Timeout (ns):"  :min 0 :max 4000000 :resolution 63

  :panel BUTTONS :layout B :padx 5 :after FOOTER
      :layout H; :row-gap 5
      :button GIRREDISPLAY  :label Redisplay :command click-redisplay

  :show T
  set girvisible 1
}


set alignframe [self frame-name].align
set alignvisible 0

proc start-align {} {
#  display Time Alignment setup sub frame
   global alignvisible alignframe
   if {$alignvisible==0} then {make-align} else {open-frame $alignframe}
   click-redisplay
} 

proc make-align {} {
  global env alignframe alignvisible

  :frame "$alignframe" :label "ESS Card Time Alignment Setup" :resize F :transient T

   :panel P1 :layout T :padx 5 :pady 5
      :layout V; :row-gap 5

      :slider  ALIGNBGOQA          :label "BGO QA (ns):"  :min 0 :max 630 :resolution 10 :valuex 14c
      :slider  ALIGNBGOQB          :label "BGO QB (ns):"  :min 0 :max 630 :resolution 10 :valuex 14c
      :slider  ALIGNBGOQC          :label "BGO QC (ns):"  :min 0 :max 630 :resolution 10 :valuex 14c
      :slider  ALIGNBGOQD          :label "BGO QD (ns):"  :min 0 :max 630 :resolution 10 :valuex 14c

      :slider  ALIGNCSIQA          :label "CsI QA (ns):"  :min 0 :max 630 :resolution 10 :valuex 14c
      :slider  ALIGNCSIQB          :label "CsI QB (ns):"  :min 0 :max 630 :resolution 10 :valuex 14c
      :slider  ALIGNCSIQC          :label "CsI QC (ns):"  :min 0 :max 630 :resolution 10 :valuex 14c
      :slider  ALIGNCSIQD          :label "CsI QD (ns):"  :min 0 :max 630 :resolution 10 :valuex 14c

      :slider  ALIGNGEQA           :label "Ge QA (ns):"   :min 0 :max 630 :resolution 10 :valuex 14c
      :slider  ALIGNGEQB           :label "Ge QB (ns):"   :min 0 :max 630 :resolution 10 :valuex 14c
      :slider  ALIGNGEQC           :label "Ge QC (ns):"   :min 0 :max 630 :resolution 10 :valuex 14c
      :slider  ALIGNGEQD           :label "Ge QD (ns):"   :min 0 :max 630 :resolution 10 :valuex 14c

   :panel P2 :layout T :padx 5 :pady 5
      :layout H; :row-gap 5

      :button ALIGNREDISPLAY :label Redisplay
   
  :show T
 set alignvisible 1
}



set thresframe [self frame-name].thres
set thresvisible 0

proc start-thres {} {
#  display Threshold setup sub frame
   global thresvisible thresframe
   if {$thresvisible==0} then {make-thres} else {open-frame $thresframe}
   click-redisplay
} 

proc make-thres {} {
  global env thresframe thresvisible

  :frame "$thresframe" :label "ESS Card Threshold Setup" :resize F :transient T

   :panel P1 :layout T :padx 5 :pady 5
      :layout V; :row-gap 5

      :slider  THRESBGOQA          :label "BGO QA (KeV):"  :min 0 :max 250 :resolution 1 :valuex 16c
      :slider  THRESBGOQB          :label "BGO QB (KeV):"  :min 0 :max 250 :resolution 1 :valuex 16c
      :slider  THRESBGOQC          :label "BGO QC (KeV):"  :min 0 :max 250 :resolution 1 :valuex 16c
      :slider  THRESBGOQD          :label "BGO QD (KeV):"  :min 0 :max 250 :resolution 1 :valuex 16c

      :slider  THRESCSIQA          :label "CsI QA (KeV):"  :min 0 :max 250 :resolution 1 :valuex 16c
      :slider  THRESCSIQB          :label "CsI QB (KeV):"  :min 0 :max 250 :resolution 1 :valuex 16c
      :slider  THRESCSIQC          :label "CsI QC (KeV):"  :min 0 :max 250 :resolution 1 :valuex 16c
      :slider  THRESCSIQD          :label "CsI QD (KeV):"  :min 0 :max 250 :resolution 1 :valuex 16c

   :panel P2 :layout T :padx 5 :pady 5
      :layout H; :row-gap 5

      :button THRESREDISPLAY :label Redisplay
   
  :show T
 set thresvisible 1
}

