/********************************************************************************/
/********************************************************************************/
/*										*/
/*				recsaroc.asm pour Cluster Ge			*/
/********************************************************************************/
/********************************************************************************/

#include "def21060.h"
#define nbdata 16
#define m 0x2000

.GLOBAL transdma;
.GLOBAL data;

/******************************************************************************/
.segment /pm     ep1_svc;	/* 0x44 a 0x47 */
/******************************************************************************/
	jump ep1_tx;		/* segment interruption DMA */

.endseg;

/******************************************************************************/
.segment /dm dm_dma;		/* 0x26100 a 0x261FF */
/******************************************************************************/

.var data[nbdata]= "data.dat";	/* buffer source memint dsp tgir*/
.endseg;


/******************************************************************************/
.segment /pm pm_dma;		/* 0x20A00 a 0x20CFF */
/******************************************************************************/

transdma :	 	/* start dma */
	/*--------------------------------------------------------------*/
  	/* 		initialisation du DMA7 en mode transmission	*/
	/* reg de contr   0  0  0  0  / 0  1  0 0 / 0 0 0 0 / 0 1 0 1   */
	/* 	  DMAC7   15 14 13 12 / 11 10 9 8 / 7 6 5 4 / 3 2 1 0   */
	/*			mode slave internal			*/
	/*--------------------------------------------------------------*/
	r4=m;					/* 0x2000, flush du DMA */			

flushdma :	dm(DMAC7)=r4;		/* on flush le DMA7, r4=0x2000 */
	r0=0x26100; dm(II7)=r0;		/* pointeur au debut du buffer emission dans la memint */
	r0=1; dm(IM7)=r0;     		/* increment */
	r0=nbdata; dm(C7)=r0;     		/* taille des buffers */

	lcntr = 40, do boucle until lce; 
	nop;nop;nop;			/* attend 4s */
	boucle : nop;

	bit set astat FLG0; 		/* debut transfert dma */
	r0=0x405;  dm(DMAC7)=r0;	/* enable le DMA7 */

	r1=dm(C7); dm(ver0)=r1;

testdc7 :r2=dm(DMAC7); BTST r2 by 15;		/* test si le buffer DMA est pret */
	if sz jump testdc7;			/* le bit 15 doit etre a 1 */


testc7 :r2=dm(DMAC7); BTST r2 by 15;		/* test si le buffer DMA est vide */
	if not sz jump testc7;			/* le bit 15 doit etre a 0 */

	bit clr astat FLG0; 		/* transfert dma termine */
	r1=dm(C7); dm(ver1)=r1;

	r2=dm(nbtransf);
bit clr astat FLG1;

rts(db);
	r2=r2+1; dm(nbtransf)=r2;	/* nb de transfert DMA saroc vers DSP	*/



/******************************************************************************/
pause :       

	dm(choix)=r14; 
 	bit clr imask IRQ0I;	/* disable l'interruption DMA */
	bit clr astat FLG2;	/* stop dma */
	dm(DMAC7)=r4;		/* r4=0x2000 */
	dm(LCTL)=r15; 		/* disable le link buffer 4 */
rts(db);
	r14=BCLR r14 BY 0; dm(0x2FFD0)=r14;

/******************************************************************************/
ep1_tx : 
	r1=0x2000; dm(DMAC7)=r1;
	bit clr imask EP1I;

	rti;		/* segment Interruption IRQ1 */

/******************************************************************************/
.endseg;
/******************************************************************************/