#    part of the Diagnostic task for testing GIR DSP functions
#    this is girstatus.tcl

#    the following table information for the GIR is taken from the file  gir.tcl


set table(GIRROCREVNUMDATADISABLE) {girevnumdatadisable logic-widget->param param->logic-widget "GIR.ROCR.EvNumData.Disable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCREVNUMQBITSENABLE) {girevnumqbitsenable logic-widget->param param->logic-widget "GIR.ROCR.EvNumQbits.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRVALACKTIMEOUTRESET) {girrocrvalacktimeoutreset logic-widget->param param->logic-widget "GIR.ROCR.ValAck.TimeOutReset"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

# definir le register
#set table(GIRROCRFILTER) {girrocrfilter int-widget->param param->int-widget "GIR.ROCR.FILTER"
#                     int-reg->param param->int-reg nil :choice   nil nil nil 1 "DSP Mode"}

set table(GIRDCRSPECTRE) {girdcrspectre logic-widget->param param->logic-widget "GIR.DSP.Spectre"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCRSCALER) {girdcrsaler logic-widget->param param->logic-widget "GIR.DSP.Scaler"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSREVFAULTSTATUS)    {girrotsrevfaultstatus    int-widget->param param->hex-widget "GIR.ROTSR.EvFault.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRFIFOSTATUS)    {girrotsrfifostatus    int-widget->param param->hex-widget "GIR.ROTSR.FIFO.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRSAROCSTATUS)    {girrotsrsarocstatus    logic-widget->param param->logic-widget "GIR.ROTSR.SAROC.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRTEMPSTATUS)    {girrotsrtempstatus    int-widget->param param->TEMP-widget "GIR.ROTSR.Temp.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRVALACKTIMEOUTSTATUS) {girrotsrvalacktimeoutstatus  logic-widget->param param->logic-widget "GIR.ROTSR.ValAck.TimeOut.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRVALACKTIMEOUT)    {girvalacktimeout    slider-widget->param param->int-widget "GIR.ValAck.TimeOut"
                     unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}


#    conversion procedures taken from common.vxi.tcl


#
#    procedures used to convert a widget value into a parameter  ##############################
#


proc int-widget->param {p v s} {global $p; set $p $v}

proc hex-widget->param {p v s} {global $p; set $p $v}

proc str-widget->param {p v s} {global $p; set $p $v}

proc logic-widget->param {p v s} {global $p; set $p [expr $v & 1]}

proc widget->param {p v s} {global $p; set $p $v}

proc slider-widget->param {p v s} {
	global $p 
	set oldv [set $p]

	if {$v==$oldv+1} then {set v [expr $oldv+$s]}
	if {$v==$oldv-1} then {set v [expr $oldv-$s]}
	set $p $v
}

#
#    procedures used to convert a register value into a parameter    #############################
#

proc reg->param {p v} {global $p; set $p $v}

proc int-reg->param {p v} {global $p; set $p [scan-int $v]}

proc str-reg->param {p v} {global $p; set $p $v}

proc int-reg->choice-param {p v} {}

proc unit-reg->param {p v} {global $p; set $p [scan-int $v]}

proc not-reg->param {p v} {global $p; set $p [expr [scan-int $v]^1]}


#
#    procedures used to convert a parameter into a widget value   ############################
#

proc param->TEMP-widget {p v u} {
#    insert-debug "param->TEMP-widget $p $v $u"
    switch $v {
       2  {set s higher}
       1  {set s lower}
       3  {set s ok}
       default {set s ??}
    }
    return "$p :value $s"
}
proc param->int-widget {p v u} {return "$p :value $v" }

proc real-param->int-widget {p v u} {return "$p :value [truncate [expr $v+0.5]]"}

proc param->logic-widget {p v u} {
   if {$v == 0} then {set vl 0} else {set vl 1}
   return "$p :value $vl" 
}

proc param->str-widget {p v u} {return "$p :value $v" }

proc param->hex-str-widget {p v u} {format "%s :value 0x%x" $p $v }

proc param->hex-widget {p v u} {format "%s :value 0x%x" $p $v }


proc param->choice-widget {p v u} {}

proc param->reg {p v u} {return "$v"}

proc param->int-reg {p v u} {return "$v"}

proc param->unit-reg {p v u} {return "$v$u"}
proc param->unit-reg {p v u} {global $p; return "[set $p]$u"}

proc param->not-reg {p v u} {return "[expr $v^1]"}

proc param->spare-reg {p v u} {puts stderr "param->spare-reg $p $v $u"; return "$v"}



proc Redisplay {} {
  global CurrentVXIModule table

  foreach widget [array names table] {
     set entry $table($widget)
     set reg [lindex $entry 3]

     if {$reg == "nil"} then {continue}

     set data [read-vxi-register $CurrentVXIModule.$reg]

     set param [lindex $entry 0]
     set p2w [lindex $entry 2]
     set r2p [lindex $entry 4]
     set unit [lindex $entry 6]
     $r2p $param $data
     global $param
     set data [set $param]
     eval :modify [$p2w $widget $data $unit]
  }
}


proc click-GIRwindow  {w v} {
    switch -glob $w {
      GIRVALACKTIMEOUT -
      GIRDCR*     -
      GIRROCR*    -
      GIRROTSR*    {click-on $w $v}
   }
}


proc click-on {w v} {
   global CurrentVXIModule table

   set entry "$table($w)"
   set param [lindex $entry 0]
   set w2p [lindex $entry 1]
   set p2w [lindex $entry 2]
   set reg [lindex $entry 3]
   set p2r [lindex $entry 5]
   set unit [lindex $entry 6]
   set step [lindex $entry 10]

   $w2p $param $v $step

   if {$reg!="nil"} then {
       write-vxi-register $CurrentVXIModule.$reg [$p2r $param $v $unit]
   }

   Redisplay
}


proc click-girrocrfilter {p v} {
global $p modefilter CurrentVXIModule
 set $p $v


        set datarocr [read-vxi-register $CurrentVXIModule.GIR.ROCR]

log " rocr = $datarocr"
switch $v {
0 {
	set v 0xfbff
	set datarocr [expr ($v&$datarocr)]
	write-vxi-register $CurrentVXIModule.GIR.ROCR $datarocr
	write-vxi-register $CurrentVXIModule.GIR.DSP.FilterMode 0
}


1 {
	set v [expr ($v*0x400)]
	set datarocr [expr ($v|$datarocr)]
	write-vxi-register $CurrentVXIModule.GIR.ROCR $datarocr
	write-vxi-register $CurrentVXIModule.GIR.DSP.FilterMode 1
}
}

}



set col1 40c

  :frame [self frame-name].gir :label "GIR Status" :show-footer T :resize F :transient T 

  :panel PANEL1 :layout T :padx 5 :pady 5
    :layout V; :row-gap 5; :col-gap 5

      :message M1 :label "Readout Control Register" :bold T
      :checkbox GIRROCREVNUMDATADISABLE   :label "Event Number Readout Disable:"          :valuex $col1
      :checkbox GIRROCREVNUMQBITSENABLE  :label "Use Event Number Qbits:"               :valuex $col1
      :checkbox GIRROCRVALACKTIMEOUTRESET :label "Enable Valack Timeout Reset"          :valuex $col1
      :choice GIRROCRFILTER :label "DSP Mode" :strings [list Spy Filter] :value 0   :valuex $col1 :command click-girrocrfilter 

      :vskip 10
      :message M2 :label "DSP Process Select"  :bold T
      :checkbox GIRDCRSPECTRE  :label "Enable Spectra" :valuex $col1
      :checkbox GIRDCRSCALER  :label "Enable Scaler" :valuex $col1


      :vskip 10
      :message M3 :label "Readout and Temperature Status Register"  :bold T
      :text    GIRROTSREVFAULTSTATUS     :label "Event Number fault Status:"   :valuex $col1 :w 6
      :text    GIRROTSRFIFOSTATUS        :label "FIFOs Status:"                :valuex $col1 :w 6
      :text    GIRROTSRTEMPSTATUS        :label "Temperature Sensor Status:"   :valuex $col1 :w 6
      :checkbox GIRROTSRSAROCSTATUS      :label "SAROC not empty:"             :valuex $col1 :deaf T
      :checkbox GIRROTSRVALACKTIMEOUTSTATUS     :label "ValAck Timeout Asserted:"       :valuex $col1 :deaf T
        
      :slider  GIRVALACKTIMEOUT          :label "ValAck Timeout (ns):"  :min 0 :max 4000000 :resolution 63
      :button GIRREDISPLAY  :label Redisplay :command Redisplay
    :show T


   Redisplay
