#    Diagnostic task for testing GIR DSP functions
global chansel
set frame GIR
set title "GIR Control"
set icon Gir

set started 0
set Testing 0

set TclBase [file join $env(MIDASBASE) vxi tcl gir]
#set girdspBase [file join $env(MIDASBASE) DspLdr]

if {[info exists env(VXIServer)] == 0} then {set VXIServer VXI}  \
   else {set VXIServer $env(VXIServer)}

set modulelist {}
set moduleindex 0

set CurrentVXIServer ""
set CurrentVXIModule ""

#    for use by spectre until replaced
set slot 0
set server ""

#    by default assume GIR V4
set girversion 4

#    the following variable are setup when the GIR version is known
#    they are set whenever a slot is selected (proc click-slot)
set offset34 0x1
set dsp 0x400000
set tdsp 0xC00000

set ldrfile ""
set file ""


set cardmenu [list ClusterGe TGIR ClusterBGO Saphir HRGe8x ESS ECC GOCCE]
set card [first $cardmenu]
set stage 0

#    general program for DSP
set genprogmenu [list "Show internal memory" "Show external memory" "DSP Registers" "Test external memory"]
set genprog ""
set genprogfiles [list visumemint.tcl visumemext.tcl regdsp.tcl sramtest.tcl]

loadsource common.vxi
loadsource vxicontrol.common

set LogFlag 0



set table(GIRSPECTRESTATUS) {girdspspectre logic-widget->param param->logic-widget "GIR.DSP.Spectre"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRSCALERSTATUS) {girdspscaler logic-widget->param param->logic-widget "GIR.DSP.Scaler"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

#    this is the initial frame displayed at startup
#    contains only a choice for the VXI card to be used initially

proc logic-widget->param {p v s} {global $p; set $p [expr $v & 1]}

proc param->logic-widget {p v u} {
   if {$v == 0} then {set vl 0} else {set vl 1}
   return "$p :value $vl" 
}
proc int-widget->param {p v s} {global $p; set $p $v}
proc int-reg->param {p v} {global $p; set $p [scan-int $v]}

proc param->int-reg {p v u} {return "$v"}
#####################
proc make-frame {} {
  global env stage cardmenu card

   set stage 0

  :frame [self frame-name] :label "[self frame-title]" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F

   :panel P1 :layout T :padx 10 :pady 10
     :layout H; :col-gap 10; :row-gap 5
     :choice-stack CARD :label "Card type choice" :strings $cardmenu :value [lsearch $cardmenu $card]


     :button START :command start_progdsp
:show T

}

#####################
proc click arg {
   global TclBase genprogfiles
   global _frame

   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]
#   insert-debug "click $arg"
   if {$c==":quit"} then {return [click-quit $f]}
   clear-footer
   set _frame [self frame-name].[third [split [:path $w] .]]
   switch -glob $w  {
      CARD     {click-card $i}
      MODULE   {click-module $i}
      GENPROG  {
          set z [catch {uplevel #0 source [file join $TclBase [lindex $genprogfiles $v]]} m]
          if {$z != 0} then {set-footer $m}
      }
      GIR*         {click-GIRwindow $w $v}

      default {
         set p "click-[lowercase $w]"
         if {[info procs $p] == "$p"} then {$p $v} else {set-footer "no handler for widget $w"}
      }
   }
}


proc click-GIRwindow  {w v} {
    switch -glob $w {
      GIRVALACKTIMEOUT -
      GIRDCR*     -
      GIRROCR*    -
      GIRTCR*     -
      GIRROTSR*    {click-on $w $v}
   }
}


#    inital application start - just builds the initial frame containing the server
#    choice



#####################
proc start args {
   global started
   if {$started == 0} then {make-frame} else {open-frame}
   set started 1
}

proc start_with_card {card} {
    global cardmenu TclBase ldrfile girversion 
    start
    :modify CARD  :value [lsearch $cardmenu $card]
    click-card $card

    start_progdsp

    set ldrfile [file join $TclBase DspLdr $girversion $card.ldr]
    :modify FWPROG  :value $ldrfile
}

proc show_gir_status {card} {
    start_with_card $card
    click-girstatus
}


#    starts the PROGDSP in full once a module has been selected

#####################
proc start_progdsp {} {
   global env stage TclBase card modesingle
   global modulelist moduleindex
   global genprog genprogmenu
   global ldrfile

   set stage 1
   global _frame
   set _frame [self frame-name]

   :modify START :inactive T
   :panel P2 :layout T :padx 10 :pady 10
     :layout H; :col-gap 10; :row-gap 5

     :text FWPROG     :label "DSP file" :value $ldrfile :w 40
     :next-row T
     :message M1  :label "GIR DSP PROGRAM" :bold T
     :button DOWNLOAD :label "Download" :command "click-download DSP"
     :button LDR      :label "Load" :command "click-ldr DSP" 
     :button CHOOSE   :label "Select"
     :next-row T

     :message M2  :label "TGIR DSP PROGRAM" :bold T
     :button TDOWNLOAD :label "Download" :command "click-download TDSP"
     :button TLDR      :label "Load" :command "click-ldr TDSP"
     :button TCHOOSE   :label "Select" :command click-choose

   :panel P3 :layout T :padx 10 :pady 10
     :layout H; :col-gap 5; :row-gap 5
     :message SETUP  :label "Check and Setup Card"
     :next-row T; :vskip -4
     :button POWSUP :label "Check Power Supply" 
     :button PZ :label "Adjust PoleZero"
     :next-row T
     :button GIRSTATUS :label "GIR Status"  :command click-girstatus
     :next-row T; :vskip 10
     :message HISTO  :label "DAQ"
     :button GIRDSPSPECTRE  :label "RESULTS" :command click-daqresults
     :checkbox GIRSPECTRESTATUS :label "Spectre" :deaf T
     :checkbox GIRSCALERSTATUS :label "Scaler" :deaf T
   :panel P4 :layout T :padx 10 :pady 10
     :layout V; :col-gap 10; :row-gap 5
     :choice-stack MODULE    :label "VXI module choice"  :strings $modulelist  :value $moduleindex

     :galley LOG :rows 8 :cols 40 :deaf T :font variable
     :button EMPTYLOG :label "Empty program log window" :command ":modify LOG :empty T"
      :next-col T
      :button GIRREDISPLAY  :label Redisplay :command Redisplay


   :panel P5 :layout T :padx 10 :pady 10
     :layout H; :col-gap 10; :row-gap 5
     :choice-stack GENPROG :label "Diagnostics" :strings $genprogmenu
     set genprog [lindex $genprogmenu 0]
     :button FINISH :command click-quit

     update

     make-modulelist
     make-myserver

     click-module $moduleindex

}


proc Redisplay {} {
#####################
  global CurrentVXIModule table

  foreach widget [array names table] {
     set entry $table($widget)
     set reg [lindex $entry 3]

     if {$reg == "nil"} then {continue}

     set data [read-vxi-register $CurrentVXIModule.$reg]

     set param [lindex $entry 0]
     set p2w [lindex $entry 2]
     set r2p [lindex $entry 4]
     set unit [lindex $entry 6]
     $r2p $param $data
     global $param
     set data [set $param]
     eval :modify [$p2w $widget $data $unit]
  }
}

#####################
proc log {string} {:modify LOG :strings $string\n}


#####################
proc click-card {v}  {
    global stage card moduleindex TclBase ldrfile girversion
    set card $v

    set ldrfile [file join $TclBase DspLdr $girversion $card.ldr]

    if {$stage == 0} then {return}
    make-modulelist
    make-myserver

    click-module $moduleindex
    :modify FWPROG  :value $ldrfile
}

#####################
proc click-module {v}  {
    global moduleindex
    set moduleindex $v
    make-myserver
    setup_module
Redisplay
}

#####################
proc setup_module {} {
   global CurrentVXIModule CurrentVXIServer
   global card moduleindex ldrfile
   global TclBase girversion offset34 dsp
   global server slot

   set CurrentVXIModule $card$moduleindex

#    the following still be to done
# on integre ici la recherche de la version de GIR pour les cartes
# clusterbgo et clusterge

#	set length 1
#      	set syscon 0
#	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $syscon -l $length"	


#set datasyscon [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
set datasyscon [read-vxi-register $CurrentVXIModule.GIR.DSP.Syscon]
log "datasyscon=$datasyscon"
if {($datasyscon == 0x0)||($datasyscon == 0xffff0000)} then { 
log "datasyscon=$datasyscon, on relit le syscon"

#set datasyscon [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
set datasyscon [read-vxi-register $CurrentVXIModule.GIR.DSP.Syscon]
log "datasyscon=$datasyscon"

 }



   switch $card {

TGIR -
GOCCE -
ESS {
          set girversion 5
       }

       default {
         if {($datasyscon <= 0x6400)&&($datasyscon != 0)} then { 
            set girversion 4
            log "datasyscon=$datasyscon, girversion$CurrentVXIModule=$girversion"
         }

         if {($datasyscon >= 0x100000)&&($datasyscon != 0xffff0000)} then {
            set girversion 3 
            log "datasyscon=$datasyscon, girversion$CurrentVXIModule=$girversion"
         }
       }
    }

   set ldrfile [file join $TclBase DspLdr $girversion $card.ldr]

#    setup variables "server" and "slot" used by spectre 
   set server $CurrentVXIServer
   set attributes [read-vxi-attribute $CurrentVXIModule.VXI.Passed]
   set slot [string range [first $attributes] 2 end]

   set-footer "slot $slot in crate $server setup as card $card"
}

#####################
proc click-choose args {
    global env ldrfile card CurrentVXIModule girversion TclBase
#    Here use the built in browser function
#    This uses the canvas function and requires a pale coloured background

    option add *Canvas.background  #c0c020
    set types {
      {{DSP Program Files}  {.ldr}   }
      {{All Files}          *        }
    }

    set file [tk_getOpenFile -parent [self frame-name] -title "GIR DSP Program Selection"  \
       -initialdir [file join $TclBase DspLdr $girversion] -filetypes $types]
    option add *Canvas.background  $env(tkcanvasbackground)
    if {$file == ""} then {return}

    set ldrfile $file
    :modify FWPROG :value $ldrfile 
}
#####################
proc click-download {whichdsp} {
   global CurrentVXIModule ldrfile

    click-choose

    set-footer "Downloading GIR DSP program"
    modify-vxi-register $CurrentVXIModule.GIR.$whichdsp.Program "-m 1"

    write-vxi-register $CurrentVXIModule.GIR.$whichdsp.Program $ldrfile
    modify-vxi-register $CurrentVXIModule.GIR.$whichdsp.Program "-m 0"
    log "Downloaded DSP program file $ldrfile"
    clear-footer
}

#####################
proc click-ldr {whichdsp} {
    global env TclBase girversion  card
    global ldrfile
    global CurrentVXIModule

    set z [midas-confirmation "Loading $ldrfile into DSP \
		in a GIR V$girversion in card  $CurrentVXIModule\n"]
    if {$z == 0} then {return}

    set-footer "Resetting GIR DSP"
    write-vxi-register $CurrentVXIModule.$whichdsp.Reset 1
    write-vxi-register $CurrentVXIModule.$whichdsp.Reset 0
    set-footer "Loading GIR DSP program"
    modify-vxi-register $CurrentVXIModule.GIR.$whichdsp.Program "-v $girversion -m 2"
    write-vxi-register $CurrentVXIModule.GIR.$whichdsp.Program $ldrfile
    modify-vxi-register $CurrentVXIModule.GIR.$whichdsp.Program "-m 0"
    log "Loaded DSP with $ldrfile"
    clear-footer


Redisplay
}

#####################
proc click-powsup args {
 global TclBase card CurrentVXIModule
   
    write-vxi-register $CurrentVXIModule.GIR.DSP.StartDSP 0
    write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 1

switch $card {
	ClusterGe  -
        ClusterBGO -
        Saphir {uplevel #0 source [file join $TclBase muxalim.tcl]}
	TGIR -
        ESS -
	ECC -
	GOCCE -
	HRGe8x {uplevel #0 source [file join $TclBase exomuxalim.tcl]}
		}

			}	

#####################
proc click-pz args {
  global TclBase card
switch $card {
	ClusterGe  -
        ClusterBGO -
        Saphir {uplevel #0 source [file join $TclBase polezero.tcl]}
	TGIR -
        ESS -
	ECC -
	GOCCE -
	HRGe8x {uplevel #0 source [file join $TclBase exopz.tcl]}
		}   
			}

#####################
proc click-girstatus args {
  global TclBase card

switch $card {
	TGIR -
        ESS -  
	ECC - 
	HRGe8x {uplevel #0 source [file join $TclBase exogirstatus.tcl]}

	GOCCE {uplevel #0 source [file join $TclBase goccegirstatus.tcl]}

        ClusterBGO -
        ClusterGe   -
        Saphir {uplevel #0 source [file join $TclBase girstatus.tcl]}
	}
			}

#####################
proc click-daqresults args {
  global  TclBase CurrentVXIModule card girversion



switch $card {
	ClusterGe
		{
		write-vxi-register $CurrentVXIModule.GIR.ROCR.DSPEN 1
		write-vxi-register $CurrentVXIModule.GIR.ROCR.MODEDMA 1

		set datarcr [read-vxi-register $CurrentVXIModule.GIR.ROCR]
		log " datarcr = $datarcr"
		set saritem0 [read-vxi-register $CurrentVXIModule.GeA.20MeV.Addr]
		set data2 0x3f00
    		set data3 [expr ($saritem0 & $data2) / 0x100]
		if {$girversion ==3} then  {set data3 [expr ($data3*0x10000)] }
		write-vxi-register $CurrentVXIModule.GIR.DSP.Item $data3
		uplevel #0 source [file join $TclBase spectre.tcl]
		}

        Saphir
		{
		write-vxi-register $CurrentVXIModule.GIR.ROCR.DSPEN 1
		write-vxi-register $CurrentVXIModule.GIR.ROCR.MODEDMA 1
		set data3 [read-vxi-register $CurrentVXIModule.Energy.Addr]
		write-vxi-register $CurrentVXIModule.GIR.DSP.Item $data3
		uplevel #0 source [file join $TclBase spectre.tcl]
		}

        ClusterBGO  
		{
		set dspmode($CurrentVXIModule) [read-vxi-register $CurrentVXIModule.GIR.DCR.DataXfer2.Enable]
		write-vxi-register $CurrentVXIModule.GIR.DSP.FilterMode $dspmode($CurrentVXIModule)


		write-vxi-register $CurrentVXIModule.GIR.DCR.DSP_Enable 1
		write-vxi-register $CurrentVXIModule.GIR.DCR.DataXfer1.Enable 1
		set data3 0
		write-vxi-register $CurrentVXIModule.GIR.DSP.Item $data3
		set spectraflag [read-vxi-register $CurrentVXIModule.GIR.DCR.Process]
		write-vxi-register $CurrentVXIModule.GIR.DSP.Process $spectraflag
		uplevel #0 source [file join $TclBase exospectre.tcl]
		}
        ESS 
		{uplevel #0 source [file join $TclBase exospectre.tcl]}

	HRGe8x {uplevel #0 source [file join $TclBase exospectre.tcl]}
	TGIR {uplevel #0 source [file join $TclBase exospectre.tcl]}
	GOCCE {uplevel #0 source [file join $TclBase exospectre.tcl]}
	ECC {uplevel #0 source [file join $TclBase exospectre.tcl]}

	}


Redisplay
}		


#    procedure to execute a  command script file in the DspExec directory
#####################
proc execute_file {n}  {
  global TclBase server
    set f [file join $TclBase DspExec $n]
    if {![file exists $f]} then {
       midas-warning "Unable to access file $n\n$f"
       return
    }
    uplevel #0 source $f
}


#    procedures taken from the vxicontrol task 

#####################
proc make-modulelist {} {
	global debug VXIServer card modulelist moduleindex

	   set modulelist {}

	   set pattern '/$VXIServer/$card\[?,??,???\].VXI.Passed'

	   if {![catch {eg "(register :pattern $pattern ?names)" } list]} then {
		foreach name $list {
                   if {[string last # $name] == -1} then {
			 scan $name [set card]%d number
			 lappend modulelist $number
                    }
		}
	   }

        set modulelist [lsort -integer $modulelist]
	if {[llength $modulelist] == 0} then {set modulelist ???}
	if {$modulelist == "???"} then {
           set moduleindex -1
	} else {
	   if {$moduleindex >= [llength $modulelist] || $moduleindex < 0} then {
              set moduleindex 0
           }
        }
        :modify MODULE :strings $modulelist :value $moduleindex


}

#####################
proc make-myserver {} {
   global modulelist moduleindex card 
   global CurrentVXIServer VXIServer

  if {$moduleindex < 0} then {
     set CurrentVXIServer $VXIServer
  } else {
     set CurrentVXIServer [VXImodule2crate $card$moduleindex]
  }

}

set vxicontrolstarted 0

#####################
proc VXImodule2crate {module} {
  global vxicontrolstarted

#    obtain crate holding a specific module
#    this uses the task  "vxicontrol"

  if {$vxicontrolstarted == 0} then {
     set started [inform vxicontrol inquire started]
     if {$started == 0} then {inform vxicontrol make-frame}
     set vxicontrolstarted 1
  }

  set crate [send vxicontrol VXImodule2crate $module]
  return $crate
}

#####################
proc taskDelay {t} {after $t}

if {$Testing == 1} then {
proc EG {args} {log "EG $args"; return 1}
}






