#gm.tcl -- new gainmatch tcl

#    conversion for tk use

set debug 0
set started 0

set framename GM
set frametitle "Gainmatch Setup for Sort"
set icontitle  "GainMatch"

set specserver 0
set specservernames {/hist /localdisc /disc}
set specservername ""

set specdir ""

set selectopt 0
set selectoptnames {
   *.4MeV.q0
   Clover*.4MeV.q0
   Ge*.4MeV.q0
   Clover*.GeA.4MeV.q0
   Clover*.GeB.4MeV.q0
   Clover*.GeC.4MeV.q0
   Clover*.GeD.4MeV.q0
   custom
   }
set patternmatch ""

set source 0
set sourcenames {Eu152 Co60}

set voverc 0.0
set configfile "/eg/config/position_to_group"
set outputfile "$env(HOME)/"

set confirmcontinue ""

set details 0
set selection {}
set filelist {}
set dirlist {}

# Co60 and Eu152 parameters
set co(0) 1173.0; set co(1) 1332.0
set eu(0) 121.78; set eu(1) 244.69; set eu(2) 344.27; set eu(3) 778.90
set eu(4) 964.131; set eu(5) 1112.12; set eu(6) 1408.01
##set euI(0) 1362.0; set euI(1) 358.0; set euI(2) 1275.0; set euI(3) 619.0
##set euI(4) 692.0; set euI(5) 649.0; set euI(6) 1000.0
set peak(C) 0.0; set peak(deltaC) 0.0
set peak(E) 0.0; set peak(deltaE) 0.0
set peak(BA) 0.0; set peak(PA) 0.0; set peak(W) 0.0
set coef(A) 0.0; set coef(B) 0.0; set coef(C) 0.0; set coef(D) 0.0

set seg(phase1)  0
set seg(A)       0
set seg(B)       1
set seg(C)       2
set seg(D)       3

set segletters {A B C D}

# Eurogam phase 2 detector position number/angle mapping:
#  1--30: Ge
# 31--54: Clover
set pos_to_angle {
{} {157.6} {157.6} {157.6} {157.6} {157.6}
{133.6} {133.6} {133.6} {133.6} {133.6}
{133.6} {133.6} {133.6} {133.6} {133.6}
{46.4} {46.4} {46.4} {46.4} {46.4}
{46.4} {46.4} {46.4} {46.4} {46.4}
{22.4} {22.4} {22.4} {22.4} {22.4}
{100.0 100.0 109.0 109.0} {71.0 71.0 80.0 80.0}
{100.0 100.0 109.0 109.0} {71.0 71.0 80.0 80.0}
{100.0 100.0 109.0 109.0} {71.0 71.0 80.0 80.0}
{100.0 100.0 109.0 109.0} {71.0 71.0 80.0 80.0}
{100.0 100.0 109.0 109.0} {71.0 71.0 80.0 80.0}
{100.0 100.0 109.0 109.0} {71.0 71.0 80.0 80.0}
{109.0 109.0 100.0 100.0} {80.0 80.0 71.0 71.0}
{109.0 109.0 100.0 100.0} {80.0 80.0 71.0 71.0}
{109.0 109.0 100.0 100.0} {80.0 80.0 71.0 71.0}
{109.0 109.0 100.0 100.0} {80.0 80.0 71.0 71.0}
{109.0 109.0 100.0 100.0} {80.0 80.0 71.0 71.0}
{109.0 109.0 100.0 100.0} {80.0 80.0 71.0 71.0}
}

set gmx 180
set gmw 37

if {$env(TCLWM) == "xv"} then {

proc make-frame {} {
  global gmx gmw
  xv  "(:frame GM :label 'Gainmatch Setup for Sort'
         :show-footer T :shrink-wrap T  :resize F
         :icon (:icon :image eg-array :transparent T :label 'Gainmatch')
    (:panel PANEL1 :x 0 :y 0 :w 500 :h 300 :row-gap 15 :layout V
       (:choice-stack SPECSERVER :label 'Spectrum server:' :valuex $gmx
              :valuey 10
              :value 0)
       (:text SPECDIR :label 'Spectrum directory:' :w $gmw :valuex $gmx)
       (:choice-stack SELECTOPT :label 'Selection pattern:' :valuex $gmx
              :value 0)
       (:text SELECTSTRING :label 'Custom pattern match:' :w 20 :valuex $gmx
              :read-only T)
       :row-gap 40
       (:choice-stack SOURCE :label 'Calibration source:' :valuex $gmx
              :value 0)
       :row-gap 15
       (:text VOVERC :label 'v/c for reaction:'  :w 10 :valuex $gmx
             :value '0.0')
       (:text CONFIGFILE :label 'Array configuration file:' :w $gmw
              :valuex $gmx)
       (:text OUTPUTFILE :label 'Gainmatch output file:' :w $gmw
              :valuex $gmx)
    )
    (:panel PANEL4 :x 500 :y 10 :w 220 :h 290
       (:message MSG4 :label '       gainmatch spectra' :x 10 :y 0 :bold T)
       (:list SPECLIST :x 0 :y 15 :rows 15 :list-width 200 :strings('')
              :read-only T)
    )
    (:panel PANEL5 :x 0 :y 300 :w 720 :h 50
       (:button HELP       :label 'Help'      :x  80  :y 10)
       (:button RUN        :label 'Run'       :x 330  :y 10)
       (:button REFRESH    :label 'Refresh' :x 580  :y 10)
    )
    (:panel PANEL6 :x 0 :y 350 :w 720 :h 20 :layout H
       (:message MSG6 :bold T :deaf T :valuex 460 :valuey 6
             :label 'E R R O R    M E S S A G E S')
    )
    (:galley GALLEY :x 0 :y 370 :read-only F :rows 16 :cols 100)
    :show T)"
}
}

if {$env(TCLWM) == "tk"} then {

proc make-frame {} {
  global env gmx gmw

  :frame "[self frame-name]" :label "[self frame-title]"  \
         :icon-image "@$env(ICONHOME)/egarray" \
         :icon-name "[self icon-title]" \
      :show-footer T

  :panel PANEL5 :layout B :w 730 :h 230
     :layout V
     :message MSG6 :bold T :valuex 460 :label "E R R O R    M E S S A G E S"
     :list GALLEY  :x 5 :rows 12 :cols 100 :deaf T

  :panel PANEL3 :layout B :w 720 :h 40 :col-gap 140
     :layout H
     :next-col T
     :button HELP       :label Help
     :button RUN        :label Run
     :button REFRESH    :label Refresh

  :panel PANEL1 :layout H :w 500 :h 310 :row-gap 8
     :layout V 
     :choice-stack SPECSERVER :label "Spectrum server:" :valuex $gmx :y 10 :value 0
     :text SPECDIR :label "Spectrum directory:" :w $gmw :valuex $gmx
     :choice-stack SELECTOPT :label "Selection pattern:" :valuex $gmx :value 0
     :text SELECTSTRING :label "Custom pattern match:" :w 20 :valuex $gmx
     :row-gap 25
     :choice-stack SOURCE :label "Calibration source:" :valuex $gmx :value 0
     :row-gap 8
     :text VOVERC :label "v/c for reaction:"  :w 10 :valuex $gmx :value "0.0"
     :text CONFIGFILE :label "Array configuration file:" :w $gmw :valuex $gmx
     :text OUTPUTFILE :label "Gainmatch output file:" :w $gmw :valuex $gmx
 
  :panel PANEL2 :layout H :w 220 :h 300
     :layout V
     :message MSG4 :label "gainmatch spectra" :x 50 :y 0 :bold T
     :list SPECLIST :x 0 :y 25 :rows 15 :list-width 200 :strings [list ""] :deaf T

  :show T
}
}


#------------------------------------------------------------------------------

if {$env(TCLWM) == "xv"} then {
proc quote-list l {
   set ll ""
   foreach f $l {append ll " " "'$f'"}
   return $ll
   }
}

proc init-gm-frame {} {
   global debug
   global errorCode
   global started framename
   global env
   global specserver specservernames specservername
   global patternmatch selectopt selectoptnames
   global source sourcenames sourcename
   if {$debug} then {puts stderr "init-gm-frame"}
   set started 1

# display window
   make-frame
   if {$env(TCLWM) == "xv"} then {xv "(GM :busy T)"}

   if {$env(TCLWM) == "xv"} then {
     xv "(SPECSERVER :strings ([quote-list $specservernames]) :value 0)"
     xv "(SELECTOPT :strings ([quote-list $selectoptnames]) :value 0)"
     xv "(SOURCE :strings ([quote-list $sourcenames]) :value 0)"
   } else {
     :modify SPECSERVER :strings $specservernames :value 0
     :modify SELECTOPT  :strings $selectoptnames  :value 0
     :modify SOURCE     :strings $sourcenames     :value 0
   }

# tcl-shell-0.999 has bug fix for setting of errorCode by exec:
# Initialise errorCode variable in case it is tested and before an error occurs
   set z [catch {error "set errorCode"} m]

# initialise widget values
#   set specserver 0
   set specservername [lindex $specservernames $specserver]

#   set selectopt 0
   if {$selectopt < 7} then {
      set patternmatch [lindex $selectoptnames $selectopt]
      }

#   set source 0
   set sourcename [lindex $sourcenames $source]

   do-repaint
   if {$env(TCLWM) == "xv"} then {xv "(GM :busy F)"}
   }

#------------------------------------------------------------------------------
proc click-specserver v {
   global env debug
   global framename specserver specservernames specservername
   if {$debug} {puts stderr "click-specserver: '$v'"}
   if {$env(TCLWM) == "xv"} then {xv "($framename :busy T)"}
   clear-footer
   set specserver $v
   set specservername [lindex $specservernames $specserver]
   if {$env(TCLWM) == "xv"} then {
     xv "(SPECSERVER :value $specserver)"
   } else {
     :modify SPECSERVER :value $specserver
   }
   if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
}

proc click-specdir s {
   global env debug
   global framename specdir
   if {$debug} {puts stderr "click-specdir: '$s'"}
   if {$env(TCLWM) == "xv"} then {xv "($framename :busy T)"}
   clear-footer
   set specdir $s
   read-selected-spectra
   paint-selected-spectra
   if {$env(TCLWM) == "xv"} then {
     xv "(SPECDIR :value '$specdir')"
   } else {
     :modify SPECDIR :value "$specdir"
   }
   if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
}

proc click-source v {
   global env framename source sourcenames sourcename
   if {$env(TCLWM) == "xv"} then {xv "($framename :busy T)"}
   clear-footer
   set source $v
   set sourcename [lindex $sourcenames $source]
   if {$env(TCLWM) == "xv"} then {
     xv "(SOURCE :value $source)"
   } else {
     :modify SOURCE :value $source
   }
   if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
}

proc click-voverc v {
   global env debug
   global framename voverc
   if {$debug} then {puts stderr "click-voverc: $v"}
   if {$env(TCLWM) == "xv"} then {xv "($framename :busy T)"}
   clear-footer
   set z [scan $v "%f" zz]
   if {$z==0} then {
      display-error-report self "Setting v/c" "invalid input: $v"
      if {$env(TCLWM) == "xv"} then {
        xv "(VOVERC :value '$voverc')"
      } else {
        :modify VOVERC :value "$voverc"
      }
      if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
      return
      }
   set voverc $v
   if {$env(TCLWM) == "xv"} then {
     xv "(VOVERC :value '$voverc')"
   } else {
     :modify VOVERC :value "$voverc"
   }
   if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
}

proc click-configfile s {
   global env framename configfile
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy T)"}
   clear-footer
   if {![file exists $s]} then {
      display-error-report self "Setting configuration file" "'$s' not found"
      } \
   else {
      if {![file isfile $s]} then \
         {display-error-report self "Setting configuration file" \
                                                   "'$s' is not a file"} \
      else \
         {set configfile $s}
      }
   xv "(CONFIGFILE :value '$configfile')"
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
   }

proc click-selectopt v {
   global env debug
   global framename selectopt selectoptnames patternmatch
   if {$debug} {puts stderr "click-selectopt: '$v'"}
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy T)"}
   clear-footer
   set selectopt $v
   set patternmatch [lindex $selectoptnames $v]
   if {$debug} {puts stderr "...patternmatch: $patternmatch"}
    if {$env(TCLWM) == "xv"} then {
      xv "(SELECTOPT :value $selectopt)"
    } else {
      :modify SELECTOPT :value $selectopt
    }
   if {$patternmatch != "custom"} {
    if {$env(TCLWM) == "xv"} then {
      xv "(SELECTSTRING :value '$patternmatch' :read-only T)"
    } else {
      :modify SELECTSTRING :value "$patternmatch"
    }
   } else {
      set patternmatch ''
    if {$env(TCLWM) == "xv"} then {
      xv "(SELECTSTRING :value '' :read-only F)"
    } else {
      :modify SELECTSTRING :value ""
    }
   }
   read-selected-spectra
   paint-selected-spectra
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
}

proc click-selectstring s {
   global env debug
   global framename patternmatch
   if {$debug} {puts stderr "click-selectstring: '$s'"}
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy T)"}
   clear-footer
   set patternmatch $s
    if {$env(TCLWM) == "xv"} then {
      xv "(SELECTSTRING :value '$patternmatch')"
    } else {
      :modify SELECTSTRING :value "$patternmatch"
    }
   read-selected-spectra
   paint-selected-spectra
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
   }

proc click-outputfile s {
   global env framename outputfile
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy T)"}
   clear-footer
   set outputfile $s
    if {$env(TCLWM) == "xv"} then {
      xv "(OUTPUTFILE :value '$outputfile')"
    } else {
      :modify OUTPUTFILE :value "$outputfile"
    }
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
   }

#------------------------------------------------------------------------------
proc sort-filelist {} {
   global filelist
   set ll {}
   foreach f $filelist {lappend ll [second $f]/[first $f]}
   set ll [lsort $ll]
   set filelist {}
   foreach f $ll {
      set s [split $f "/"]
      lappend filelist [list [second $s] [first $s]]
      }
   }

proc spec-type t {
   if {$t==1} then {return s}
   if {$t==2} then {return d}
   return ?
   }

proc make-details s {
   global debug
   global specservername specdir
   if {$debug} then {puts stderr "make-details: $specservername/$specdir/$s"}
   set z [catch {eg "(spectrum :name '$specservername/$specdir/$s' ?spec)"} m]
   if {$z!=0} then {
      display-eg-error-report self $m "Attempting to read spectrum details" \
                                      $specservername/$specdir/$s
      clear-footer
      error $m
      }
   set dim [first $m]
   set bases [second $m]
   set ranges [third $m]
   set ll ""
   if {$dim>=1} then {append ll "[first $bases]:[first $ranges]"}
   if {$dim>=2} then {append ll "x[second $bases]:[second $ranges]"}
   if {$dim>2} then {append ll "x..."}
   return $ll
   }

proc read-directory {} {
   global debug
   global specservername specdir filelist
   if {$debug} then {puts stderr "read-directory: $specservername/$specdir"}
   set z [catch {eg "(spectrum :path '$specservername/$specdir' ?names)"} m]
   if {$z!=0} then {
      display-eg-error-report self $m "Attempting to read directory" \
                                      $specservername/$specdir
      clear-footer
      error $m
      }
   set filelist $m
   sort-filelist
   make-dirlist
   }

proc select-matching-files {} {
   global filelist patternmatch selection nselected
   if {$patternmatch==""} then {set selection {}; return}
   set ll {}; set i 0; set nselected 0
   foreach f $filelist {
      set n [second $f]
      if {$n!="." && $n!=".."} then \
         {
         if {[match-name $patternmatch $n]} then {lappend ll $i; incr nselected}
         incr i
         }
      }
   set selection $ll
   }

proc read-selected-spectra {} {
   global debug
   global selectlist selection dirlist
   if {$debug} {puts stderr "read-selected-spectra"}
   read-directory
   select-matching-files
   set selectlist {}
   foreach i $selection {
      lappend selectlist [second [lindex $dirlist $i]]
      }
   }

proc paint-selected-spectra {} {
   global env debug
   global selectlist nselected
   if {$debug} {puts stderr "paint-selected-spectra"}
    if {$env(TCLWM) == "xv"} then {
      xv "(SPECLIST :show F :strings ([quote-list $selectlist]) :scroll-from 0 :show T)"
      xv "(GM :left-footer '$nselected spectra matching selection pattern')"
    } else {
      :modify SPECLIST :show F :empty T :strings $selectlist :show T
      set-footer "$nselected spectra matching selection pattern"
    }
}

proc make-selected-spectra {} {
   global dirlist selection specservername specdir
   set ll {}
   foreach i $selection {
      set n [second [lindex $dirlist $i]]
      lappend ll $specservername/$specdir/$n
      }
   return $ll
   }

proc make-dir-line {t s} {
   global debug
   global details
   if {$debug>2} then {puts stderr "make-dir-line: $t $s"}
   if {$s=="." || $s==".."} then {return ""}
   if {$t==2} then {return [format "%s   %20s" [spec-type $t] $s]}
   if {$t==1} then {
      if {$details} then {return [format "%s   %20s   %s" \
            [spec-type $t] $s [make-details $s]] } \
      else {return [format "%s   %20s" [spec-type $t] $s]}
      }
   return ""
   }

proc make-dirlist {} {
   global debug
   global filelist dirlist global dircount details
   set dirlist {}; set dircount 0
   if {$debug>1} then {puts stderr "make-dirlist: filelist=$filelist"}
   foreach p $filelist {
      set t [first $p]
      set s [second $p]
      set l [make-dir-line $t $s]
      if {$l!=""} then {
         lappend dirlist $l
         incr dircount
         }
      }
   if {$debug>1} then {puts stderr "...dirlist=$dirlist"}
   }

proc get-groupnum {s} {
   global debug
   set number -1
   set name ""
   set name [string range $s [string last "/" $s] end]
   set x [regexp "\[0-9\]+" $name number]
   if {$debug>1} then {puts stderr "group number from $name = $number"}
   return $number
   }

proc get-segment-letter {s} {
# for Clover returns single character representing Ge detector segment
# for Phase I Ge returns 'phase1'
# otherwise error
   global debug
   if {$debug>1} {puts stderr "get-segment-letter: '$s'"}
   set fname ""
# reduce to filename (remove pathname)
   set fname [string range $s [expr [string last "/" $s] + 1] end]
   switch -glob $fname  {
     Clover\[0-9\]\[0-9\].GeA.* {return A}
     Clover\[0-9\]\[0-9\].GeB.* {return B}
     Clover\[0-9\]\[0-9\].GeC.* {return C}
     Clover\[0-9\]\[0-9\].GeD.* {return D}
     Clover\[0-9\]\[0-9\].GeE.* {return E}
     Ge\[0-9\].*                {return "phase1"}
     Ge\[0-9\]\[0-9\].*                {return "phase1"}
     default                    {error "$fname"}
     }
}

proc get-angle {angles s} {
   global debug
   global segletters
   if {$debug>1} {puts stderr "get-angle: angles='$angles', s='$s'"}
   set angle [lindex $angles [lsearch $segletters $s]]
   if {$debug>1} {puts stderr "...angle='$angle'"}
   return $angle
   }

proc sort-by-number ll {
   global debug
   if {$debug>1} {puts stderr "sort-by-number: $ll"}
   set jj {}
   foreach l $ll {
     set j 0
     foreach y $jj {
       if {$l < $y} then {break}
       incr j
       }
     set jj [linsert $jj $j $l]
     }
   if {$debug>1} {puts stderr "...returning: '$jj'"}
   return $jj
   }

proc abs x {if {$x>=0} then {return $x} else {return [expr 0-$x]}}

proc list-max s {
   set m [first $s]
   foreach i $s {if {$i>$m} then {set m $i}}
   return $m
   }

proc list-min-index s {
   set m [first $s]; set i 0; set j 0
   foreach n $s {if {$n<$m} then {set m $n; set j $i}; incr i}
   return $j
   }
 
proc list-nearest {s v d} {
   set ds {}
   foreach i $s {lappend ds [abs [expr $v-$i]]}
   set i [list-min-index $ds]
   set dd [lindex $ds $i]
   if {$dd>$d} then {error "closest is $i with delta $d"}
   return [lindex $s $i]
   }

proc split-at-equal s {split $s "="}

proc trim s {string trim $s}

proc map {p ss} {
   set ll {}
   foreach s $ss {lappend ll [$p $s]}
   return $ll
   }

proc scan-float s {
   set f 0.0
   scan $s "%f" f
   return $f
   }

proc parse-peak-integrate pp {
   global peak
   foreach p $pp {
      if {[llength $p]<2} then {continue}
      set value 0.0; set value2 0.0
      set label [trim [first $p]]
      set value [scan-float [second $p]]
      set vals [split [second $p] "/"]
      if {[llength $vals]>=2} then \
         {set value2 [scan-float [string trimleft [second $vals] "-"]]}
      if {$label=="Centroid"} then \
         {set peak(C) $value; set peak(deltaC) $value2}
      if {$label=="Energy"} then \
         {set peak(E) $value; set peak(deltaE) $value2}
      if {$label=="Background area"} then {set peak(BA) $value}
      if {$label=="Peak area"} then {set peak(PA) $value}
      if {$label=="Peak width"} then {set peak(W) $value}
      }
   }

proc parse-calibrate pp {
   global coef
   foreach p $pp {
      if {[llength $p]<2} then {continue}
      set value 0.0; set value2 0.0
      set label [trim [first $p]]
      set value [scan-float [second $p]]
      set vals [split [second $p] "/"]
      if {[llength $vals]>=2} then \
         {set value2 [scan-float [string trimleft [second $vals] "-"]]}
      if {$label=="A"} then \
         {set coef(A) $value; set coef(deltaA) $value2}
      if {$label=="B"} then \
         {set coef(B) $value; set coef(deltaB) $value2}
      if {$label=="C"} then \
         {set coef(C) $value; set coef(deltaC) $value2}
      if {$label=="D"} then \
         {set coef(D) $value; set coef(deltaD) $value2}
      }
   }

proc make-calibrate-input {cs deltacs es} {
   global debug
   set lines ""
   for {set i 0} {$i<[llength $cs]} {incr i} {
      append lines "[lindex $cs $i] [lindex $es $i] [lindex $deltacs $i] 0.1 \n"
      }
   if {$debug} then {puts stdout "$lines"}
   return $lines
   }

proc update-calibrations {} {
#   xv "([selection frame]-GALLERY :refresh-calibrations T :refresh-tags T)"
#      no tk version - meaning of xv call not understood
   }

proc put-errorlog text {
   global env framename
   if {$env(TCLWM) == "xv"} then {
     xv "(GALLEY :insert '[quote $text]' :insert '\n')" 
   } else {
     :modify GALLEY :strings [list $text]
   }
}

#==============================================================================
   
proc confirm m {
   global env debug
   global confirmcontinue
   global framename
   if {$env(TCLWM) == "xv"} then {
     xv "($framename (:notice NOTICE :string '[quote $m]' \
       :no 'Cancel' :yes 'Run gainmatch' :show T))"
   } else {
     set i [tk_dialog [self frame-name].dialog "Gainmatch" "$m" "warning" 1 "Cancel" "Run Gainmatch"]
     if {$i != 0} then {eval $confirmcontinue 1}
   }
   if {$debug} then {puts stderr "confirm: $m"}
}

proc click-run {} {
   global debug
   global confirmcontinue

   set confirmcontinue "do-gainmatch-all"
   confirm "WARNING!!  Take care if running this from your experiment control session since it can take several minutes and will freeze all other EG-session windows!"
   }

proc do-gainmatch-all {yesorno} {
   global env debug
   global framename specdir
   global sourcename voverc configfile outputfile
   global eu co peak coef
   global nselected
   global pos_to_angle seg

   if {$yesorno!=1} then {
     if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
     return
   }

#------------------------------------------------------------------------------
# this function outputs the modified gain coefficients for each
# spectrum in the list by performing an auto-calibration on it and
# adjusting the channel value according to the detector angle read from a
# configuration file and the v/c for the experiment
# the results are written to an output file which is in a format suitable
# for inclusion into an online sortfile *DATA section where the gainarray name
# needs to be supplied by the user
# theory: Egam_calib = coef(A) + coef(B)*chan + coef(C)*chan*chan
#         Egam_observed  = Egam_reaction * (1 + v/c*cos(theta))
#      => shifted coefficient = calib_coeff / (1+v/c*cos(theta))
#------------------------------------------------------------------------------

    if {$env(TCLWM) == "xv"} then {xv "($framename :busy T)"}
   clear-footer

#------------------------------------------------------------------------------

# open output file...
   set z [catch {open $outputfile w} gainfd]
   if {$z!=0} then {
      display-error-report self "Cannot open output file" $gainfd
      clear-footer
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
      return
      }
   if {$debug>1} then \
      {puts stderr "opened output file: '$outputfile'..."}
   puts $gainfd "*DATA"
   puts $gainfd "!! gain coefficients calculated by sort gainmatch tool"
   puts $gainfd "!! from $sourcename source spectra for v/c=$voverc"

#------------------------------------------------------------------------------

# refresh spectrum list and update selected spectrum list...
   read-selected-spectra
   paint-selected-spectra
   set-footer "Running gainmatch on $nselected spectra..."

#------------------------------------------------------------------------------

# derive group number/detector position mapping...
   set z [catch {open $configfile} mapfd]
   if {$z!=0} {
      display-error-report self "Cannot read configuration file '$configfile'"
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
      return
      }
   if {$debug} {puts stderr "Reading config file: '$configfile'..."}
   set lineno 0
   while {[gets $mapfd line] != -1} {
      set line [string trim $line]
      incr lineno
# find beginning of comment...
      set commentpos [string first "!" $line]
# whole line comment or blank line...
      if {$commentpos == 0 || [string length $line] == 0} { continue }
# in-line comment, remove comment from line buffer...
      if {$commentpos != -1} \
         {set line [string range $line 0 [incr $commentpos -1]]}
      if {$debug>2} {puts stderr "line = '$line'..."}
# check data format...
      foreach element $line {
         if {![scan $element "%d" x]} then {
            display-error-report self \
                 "Reading configuration file" "format error: line $lineno"
            close $mapfd
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
            return
            }
         }
      set pos [lindex $line 0]
# 1-to-many mapping for position to groupnos
# note: 1st group is original groupno (for angle) and not for coeff output
      set pos_to_group($pos) [lrange $line 1 end]
      set orig_group [lindex $pos_to_group($pos) 0]
      if {$debug>1} {puts stderr "pos='$pos', groups='$pos_to_group($pos)'..."}
# also keep tabs on many-to-1 group to pos mapping, cannot reassign groupno...
      foreach group $pos_to_group($pos) {
         if {[info exists group_to_pos($group)]} then {
# not an error if original group duplicated
            if {$group == $orig_group} continue
#
            display-error-report self "Reading configuration file" \
                              "group $group redefined: line $lineno"
            close $mapfd
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
            return
            } \
         else {
            set group_to_pos($group) $pos
            }
         }
      }
   close $mapfd

#------------------------------------------------------------------------------

# compile list of spectrum names matching specified pattern option...
   set ss [make-selected-spectra]
   if {$debug} {puts stderr "ss = $ss"}

#------------------------------------------------------------------------------

# loop over spectra, save gain coefficients...

   set seg_list(phase1) {}
   set seg_list(A) {}
   set seg_list(B) {}
   set seg_list(C) {}
   set seg_list(D) {}
   set seg_list(Amod) {}
   set seg_list(Bmod) {}
   set seg_list(Cmod) {}
   set seg_list(Dmod) {}

   put-errorlog "GAINMATCH errors:---------------------------------------------------------------------------------------"
   foreach s $ss {
      set-footer "running gainmatch on $s..."

      set goto_next_spectrum 0

# derive group number from spectrum name...
      set groupnum [get-groupnum $s]
      if {$groupnum == -1} then {
         put-errorlog "Invalid gainmatch spectrum name: $s"
         put-errorlog "...cannot decode groupnum number"
         put-errorlog ""
         continue
         }

# if this element undefined ignore spectrum...
      if {![info exists group_to_pos($groupnum)]} then {
         put-errorlog "Configuration file warning: group $groupnum missing"
         put-errorlog "...cannot determine angle for $s"
         put-errorlog ""
         continue
         }
      set pos $group_to_pos($groupnum)

# derive segment letter from spectrum name...
      set z [catch {get-segment-letter $s} segletter]
      if {$z!=0} {
         put-errorlog "Invalid gainmatch spectrum name: $s"
         put-errorlog "...cannot determine segment"
         put-errorlog ""
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
         return
         }
      set segno $seg($segletter)
      if {$debug} then \
         {puts stderr "spectrum '$s': position $pos, segment '$segletter', no $segno"}

#==============================================================================

# calibrate spectrum according to source option...
      set hw 10
      if {$sourcename == "Eu152"} then {
        set-footer "finding Europium peaks for position $pos, spectrum $s..."
         set z [catch {exec peaklist  \
            -spectrum $s -limit 1 4095 -peaks 15} m]
         if {$z!=0} then {
            put-errorlog "Obtaining calibration for $s"
            put-errorlog "...$m"
            put-errorlog ""
#            clear-tags
            continue
            }
         if {[llength $m]<11} then {
            put-errorlog "Obtaining calibration for $s"
            put-errorlog "...can't find enough Europium peaks in $s"
            put-errorlog ""
            continue
            }
# the rightmost peak is invariably the 1408keV line
         set c6 [list-max $m]
         set tags {}
         set z [catch {
            foreach i {0 1 2 3 4 5 6} \
               {lappend tags [list-nearest $m [expr $eu($i)/$eu(6)*$c6] 10] }
            } m]
         if {$z!=0} then {
            put-errorlog "Obtaining calibration for $s"
            put-errorlog "...can't locate all 7 Europium peaks---is this an Eu152 spectrum?"
            put-errorlog ""
            continue
            }
#        if {$debug} then {puts stderr "Eu peaks are $tags"}
         } \
      else {if {$sourcename == "Co60"} then {
         set-footer "finding Cobalt peaks for position $pos, spectrum $s..."
         set z [catch {exec peaklist  \
            -spectrum $s -limit 1 4095 -peaks 2} m]
         if {$z!=0} then {
            put-errorlog "Obtaining calibration for $s"
            put-errorlog "...$m"
            put-errorlog ""
#            clear-tags
            continue
            }
         if {[llength $m]!=2} then {
            put-errorlog "Obtaining calibration for $s"
            put-errorlog "...can't find the two Cobalt peaks"
            put-errorlog ""
            continue
            }
         set tags $m
         }}
      set centroids {}
      set deltacentroids {}
      set widths {}
      set peakareas {}
      if {$sourcename == "Eu152"} then {
         foreach i {0 1 2 3 4 5 6} {
            set c [lindex $tags $i]
            set c1 [expr $c-$hw]
            set c2 [expr $c+$hw]
            set-footer "taking $eu($i)keV peak centroid at channel $c..."
            set z [catch {exec integrate  \
               -spectrum $s \
               -limit $c1 $c2} m]
            if {$z!=0} then \
              {
              put-errorlog "Integrating spectrum: $s"
              put-errorlog "...$m"
              put-errorlog ""
              set goto_next_spectrum 1
              break
              }
            parse-peak-integrate [map split-at-equal [split $m ",\n"]]
            lappend centroids $peak(C)
            lappend deltacentroids $peak(deltaC)
            lappend widths $peak(W)
            lappend peakareas $peak(PA)
            }
         if {$goto_next_spectrum} then \
            continue
         } \
      else {if {$sourcename == "Co60"} then {
         foreach i {0 1} {
            set c [lindex $tags $i]
            set c1 [expr $c-$hw]
            set c2 [expr $c+$hw]
            set-footer "taking $co($i)keV peak centroid at channel $c..."
            set z [catch {exec integrate  \
               -spectrum $s \
               -limit $c1 $c2} m]
            if {$z!=0} then \
              {
              put-errorlog "Integrating spectrum: $s"
              put-errorlog "... $m"
              put-errorlog ""
              set goto_next_spectrum 1
              break
              }
            parse-peak-integrate [map split-at-equal [split $m ",\n"]]
            lappend centroids $peak(C)
            lappend deltacentroids $peak(deltaC)
            lappend widths $peak(W)
            lappend peakareas $peak(PA)
            }
         if {$goto_next_spectrum} then \
            continue
         }}
      if {$debug>1} then {puts stderr "centroids are $centroids"
         puts stderr "deltacentroids are $deltacentroids"
         puts stderr "widths are $widths"}
   
      set-footer "computing calibration..."
      if {$sourcename == "Eu152"} then {
         set energies [list $eu(0) $eu(1) $eu(2) $eu(3) $eu(4) $eu(5) $eu(6)]
#         set deltacentroids [list 0.1 0.1 0.1 0.1 0.1 0.1]
         set z [catch {exec calibrate -spectrum $s \
            -opt quadratic  -units keV \
           << [make-calibrate-input $centroids $deltacentroids $energies] } m]
         } \
      else {if {$sourcename == "Co60"} then {
         set energies [list $co(0) $co(1)]
         set z [catch {exec calibrate -spectrum $s \
            -opt linear  -units keV \
            << [make-calibrate-input $centroids $deltacentroids $energies] } m]
         }}

      if {$z!=0} then {
         put-errorlog "Deriving calibration for $s"
         put-errorlog "...$m"
         put-errorlog ""
         continue
         }
      insert-log $m
      puts stdout "$m"
      update-calibrations

      parse-calibrate [map split-at-equal [split $m ",\n"]]
      if {$debug>1} then \
         {puts stderr "coef: A=$coef(A) B=$coef(B) C=$coef(C) D=$coef(D)"}

#==============================================================================

# read corresponding angle from config file info...
      if {$debug>1} then {
         set x [llength $pos_to_angle]
         puts stderr "pos=$pos, length pos_to_angle=$x"
         }

      if {$pos < [llength $pos_to_angle]} then {
         if {$debug} {puts stderr "pos: $pos..."}
         set x [lindex $pos_to_angle $pos]
         if {$debug} {puts stderr "x: $x, segno: $segno..."}
         set angles {}
         lappend angles [lindex $x $segno]
         switch $segletter  {
            {A D} {lappend angles [expr ([get-angle $x A]+[get-angle $x D])/2]}
            {B C} {lappend angles [expr ([get-angle $x B]+[get-angle $x C])/2]}
            }

         if {[lindex $angles 0]!=""} then {
            if {$debug>1} {puts stderr "angles = [lindex $angles 0] ..."}
            } \
         else {
            put-errorlog "Reading configuration file: position $pos: angle undefined"
            put-errorlog ""
            continue
            }} \
      else {
         put-errorlog "Reading configuration file: position $pos undefined"
         put-errorlog ""
         continue
         }

# lose first member in list since this is original group number in eb
# and duplicated using GROUPCOPY command so not used in sort
# output simple coeffs for first set of numbers
#    and coeffs modified by angle for subsequent sets

      set groupnumlist [lrange $pos_to_group($pos) 1 end]
      set nparams [expr [llength $pos_to_group($pos)] - 1]
      if {$debug} {puts stderr "...nparams = $nparams"}
      set nextras [expr $nparams - 1]
      if {$debug} {puts stderr "...nextras = $nextras"}

# iter=0: mult=1, iter=0: mult=2,3,4
      set iter 0
      foreach angle $angles {
      if {$debug} then \
         {puts stderr "groupnos $groupnumlist, seg $segletter, angle $angle"}
# calculate cosine of angle for this detector...
         set z [catch {exec cosine -angle $angle} m]
         if {$z!=0} then {
            put-errorlog "Deriving cosine for $s"
            put-errorlog "...$m"
            put-errorlog ""
            continue
#            close $gainfd
#    if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
#            return
            }
         if {$debug} {puts stderr "...cos $angle = $m"}
         set shift_factor [expr 1+$voverc*$m]
         if {$debug>1} {puts stderr "...shift_factor = $shift_factor"}
         set a [expr 2*$coef(A)/$shift_factor]
         set b [expr 2*$coef(B)/$shift_factor]
         set c [expr 2*$coef(C)/$shift_factor]

         if {!$iter} then {
# first angle in list (direct to segment)
            foreach i {0} {
               if {$i > $nextras} then break
               set z [catch {set groupnum [lindex $groupnumlist $i]} m]
               if {$debug} {puts stderr "...groupnum = $groupnum"}
# list for each segment...
               set segment($segletter,$groupnum) \
                                   [format "%3d (%f %f %f)" $groupnum $a $b $c]
               lappend seg_list($segletter) $groupnum
               }
            } \
         else {
# second angle in list (compound angle between 2 segments)
            foreach i {1 2 3} {
               if {$i > $nextras} then break
               set groupnum [lindex $groupnumlist $i]
# list for each segment...
               set segment($segletter,$groupnum) \
                                   [format "%3d (%f %f %f)" $groupnum $a $b $c]
               lappend seg_list($segletter) $groupnum
               }
            }
         incr iter
         switch $segletter {
            {A} {set segletter Amod}
            {B} {set segletter Bmod}
            {C} {set segletter Cmod}
            {D} {set segletter Dmod}
            }
         if {$debug>1} {puts stderr [quote-list $seg_list($segletter)]}
         }
      }

   if {$debug} then {
      puts stderr "parameters for each segment..."
      foreach segletter {phase1 A B C D Amod Bmod Cmod Dmod} \
         {puts stderr "$segletter: [quote-list $seg_list($segletter)]"}
      }

# write GAINARRAY statements and array info
   foreach segletter {phase1 A B C D Amod Bmod Cmod Dmod} {
      if {[llength $seg_list($segletter)] > 0} then {
         if {[string length $segletter] > 4} then {
            puts $gainfd "GAINARRAY  g$segletter       !! $segletter detectors"
            } \
         else {
            puts $gainfd "GAINARRAY  seg$segletter       !! segment $segletter"
            }
         set seg_list($segletter) [sort-by-number $seg_list($segletter)]
         foreach groupnum $seg_list($segletter) {
            puts $gainfd [format "%s" $segment($segletter,$groupnum)]
            }
         }
      }

   close $gainfd
   clear-footer
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
   }
#------------------------------------------------------------------------------



proc click-refresh {} {
   global env debug
   global framename
   if {$debug} {puts stderr "click-refresh: $framename"}
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy T)"}
   clear-footer
   do-repaint
    if {$env(TCLWM) == "xv"} then {xv "($framename :busy F)"}
   }

proc do-repaint {} {
   global env framename
   global specserver specdir selectopt patternmatch
   global source voverc configfile outputfile
   if {$env(TCLWM) == "xv"} then {
     xv "(SPECSERVER :value $specserver)
         (SPECDIR :value '$specdir')
         (SELECTOPT :value $selectopt)
         (SELECTSTRING :value '$patternmatch')
         (SOURCE :value $source)
         (VOVERC :value '$voverc')
         (CONFIGFILE :value '$configfile')
         (OUTPUTFILE :value '$outputfile')"
   } else {
     :modify SPECSERVER   :value $specserver
     :modify SPECDIR      :value "$specdir"
     :modify SELECTOPT    :value $selectopt
     :modify SELECTSTRING :value "$patternmatch"
     :modify SOURCE       :value $source
     :modify VOVERC       :value "$voverc"
     :modify CONFIGFILE   :value "$configfile"
     :modify OUTPUTFILE   :value "$outputfile"
   }
   read-selected-spectra
   paint-selected-spectra
}

proc click-help f {
   send mb goto [transparent "(SX)Gainmatch Setup window"]
   }

proc click arg {
   global debug confirmcontinue
   if {$debug} then {puts stderr "click with argument \{$arg\}" }
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$f=="ER"} then {remove-eg-error-report self; return}
   if {$c==":quit"} then {click-quit; return}
   switch $w  {
      SPECSERVER   {click-specserver $v}
      SPECDIR      {click-specdir $v}
      SOURCE       {click-source $v}
      VOVERC       {click-voverc $v}
      CONFIGFILE   {click-configfile $v}
      SELECTOPT    {click-selectopt $v}
      SELECTSTRING {click-selectstring $v}
      OUTPUTFILE   {click-outputfile $v}
      SPECLIST     {}
      REFRESH      {click-refresh}
      RUN          {click-run}
      NOTICE       {$confirmcontinue $v}
      HELP         {click-help $f}
      default      {puts stdout $arg}
      }
   }

proc start args {
   global started
   if {$started == 0} then {init-gm-frame} else {open-frame}
}

proc click-quit {} {
    global env started
    if {$env(TCLWM) == "xv"} then {destroy-frame; set started 0} \
    else {close-frame}
}

proc finish args {destroy-frame}

