
#     modify 1/6/99 by L.OLIVIER (GIP/GANIL)

#   gmt.defn.tcl     Ganil GMT  VXI card

#    load address definitions

loadsource GroupDefn

proc {AddGMTModule}  {module slot}  {
   global registerbase namebase cardtype 

   set registerbase $cardtype$module
   set namebase $cardtype$module

   delete-vxi-registers $registerbase.*

   GMTVXIRegisters $slot
   GMTModuleRegisters  $slot
}

proc gmt_register {registername class attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc GMTVXIRegisters {slot} {
   gmt_register     VXI.ManID      xSht   "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   gmt_register     VXI.AddrSpace  xSht   "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   gmt_register     VXI.DevClass   xSht   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   gmt_register     VXI.ModelCode  xSht   "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   gmt_register     VXI.ReqMem     xSht   "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   gmt_register     VXI.Status     xSht   "-s$slot -o4  -pro -w16 -fx"
   gmt_register     VXI.Reset      xSht   "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   gmt_register     VXI.Passed     xSht   "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   gmt_register     VXI.Ready      xSht   "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   gmt_register     VXI.ModID      xSht   "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   gmt_register     VXI.A24A32     xSht   "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   gmt_register     VXI.Offset     xSht   "-s$slot -o6  -pro -w16 -fx"
   gmt_register     VXI.SerialNum  xSht   "-s$slot -o8  -pro -w16 -fx"
   gmt_register     VXI.ModLevel   xSht   "-s$slot -o10 -pro -w16 -fx"
   gmt_register     LastCard       xSht   "-s$slot -o4  -prw -w16 -fd -b4 -l1"
}

proc GMTModuleRegisters {slot} {
   gmt_register  VXLOGADD   xSht   "-s$slot -o0 -pwo -w16"
   gmt_register  VXCONTRL   xSht   "-s$slot -o4 -pwo -w16 -i0xe1cf"
   gmt_register  VXCONTRL.MP   xSht   "-s$slot -o4 -prw -w16 -fd -b9 -l1"
   gmt_register  VXCONTRL.ZP   xSht   "-s$slot -o4 -prw -w16 -fd -b8 -l1"

   gmt_register  VXSYNCTST  xSht  "-s$slot -o0x32 -w16 -prw -b0 -l0 -i0x8001"
   gmt_register  VXVAL      xSht  "-s$slot -o0x30 -w16 -prw -b0 -l0 -i0x8000"
   gmt_register  VXINIT     xSht  "-s$slot -o0x24 -w16 -prw -b0 -l0 -i0x8003"
   gmt_register  VXWORK     xSht  "-s$slot -o0x26 -w16 -prw -b0 -l0 -i0x8004"
   gmt_register  VXINHIBIT  xSht  "-s$slot -o0x2e -w16 -prw -b0 -l0 -i0x8007"
   gmt_register  VXCT       xSht  "-s$slot -o0x2a -w16 -prw -b0 -l0 -i0x8006"
   gmt_register  VXMRST     xSht  "-s$slot -o0x28 -w16 -prw -b0 -l0 -i0x8005"
   gmt_register  VXCODING   xSht  "-s$slot -o0x20 -w16 -prw -b0 -l0 -i0x8000"
   gmt_register  VXREADOUT  xSht  "-s$slot -o0x22 -w16 -prw -b0 -l0 -i0x8001"

   gmt_register  GMT.STATUS    xDig  "-s$slot -c0 -o0x0036 -pro -w16 -fx"
   gmt_register  GMT.CONFIG    xDig  "-s$slot -c0 -o0x002c -w16 -prw -fx -b0 -l0 -i0x3200"
   gmt_register  GMT.CMD       xDig  "-s$slot -c0 -o0x0034 -w16 -pwo -fx -b0 -l0 -i0x0"

   gmt_register  GMT.MASK      xDig  "-s$slot -c0 -o0x0000 -w32 -prw -fx -b0 -l0 -i0x1ffff"
   gmt_register  GMT.STAND     xDig  "-s$slot -c0 -o0x0004 -w32 -prw -fx -b0 -l0 -i0x0"
   gmt_register  GMT.GATING    xDig  "-s$slot -c0 -o0x0008 -w16 -prw -fx -b0 -l0 -i0xffff"
   gmt_register  GMT.TYPE      xDig  "-s$slot -c0 -o0x000a -w16 -prw -fx -b0 -l0 -i0x0"
   gmt_register  GMT.WINFAG    xDig  "-s$slot -c0 -o0x0010 -w16 -prw -fx -b0 -l0 -i100"
   gmt_register  GMT.WINFRG    xDig  "-s$slot -c0 -o0x0012 -w16 -prw -fx -b0 -l0 -i0"
   gmt_register  GMT.DELSAG    xDig  "-s$slot -c0 -o0x0014 -w16 -prw -fx -b0 -l0 -i0x0"
   gmt_register  GMT.WINSAG    xDig  "-s$slot -c0 -o0x0016 -w16 -prw -fx -b0 -l0 -i0x0"
   gmt_register  GMT.WINSRG    xDig  "-s$slot -c0 -o0x0018 -w16 -prw -fx -b0 -l0 -i0x0"
   gmt_register  GMT.DELSTR    xDig  "-s$slot -c0 -o0x001a -w16 -prw -fx -b0 -l0 -i0x0"
   gmt_register  GMT.WINSTR    xDig  "-s$slot -c0 -o0x001c -w16 -prw -fx -b0 -l0 -i0x0"
   gmt_register  GMT.DELVAL    xDig  "-s$slot -c0 -o0x001e -w16 -prw -fx -b0 -l0 -i0x0"
   gmt_register  GMT.WINVAL    xDig  "-s$slot -c0 -o0x0020 -w16 -prw -fx -b0 -l0 -i100"
   gmt_register  GMT.WAITCT    xDig  "-s$slot -c0 -o0x0022 -w16 -prw -fx -b0 -l0 -i400"
   gmt_register  GMT.WAITINH   xDig  "-s$slot -c0 -o0x0024 -w16 -prw -fx -b0 -l0 -i200"
   gmt_register  GMT.EOSC      xDig  "-s$slot -c0 -o0x0026 -w16 -prw -fx -b0 -l0 -i0x1"
   gmt_register  GMT.RELEASE   xDig  "-s$slot -c0 -o0x0028 -w16 -prw -fx -b0 -l0 -i0x1"
   gmt_register  GMT.CODSET    xDig  "-s$slot -c0 -o0x002a -w16 -pwo -fx -b0 -l0 -i0x1"
   gmt_register  GMT.STATMRK   xDig  "-s$slot -c0 -o0x0060 -w16 -prw -fx -b0 -l0 -i0xe"

   gmt_register  GMT.VISU    xDig  "-s$slot -c0 -o0x003a -w16 -prw -fx -b0 -l0 -i0x0"
   gmt_register  GMT.INSP    xDig  "-s$slot -c0 -o0x003c -w16 -prw -fx -b0 -l0 -i0x0"
}

#set VXMSKAddressTable {0x0000}
#for {set c 0} {$c < 16} {incr c} {set GMTDataBits(c$c) 14}
#
#proc GMTChannelRegisters {slot c} {
#   global namebase VXMSKAddressTable DataBits
#
#   gmt_register  Addr   xAdr  "-s$slot -c$c -o0x00 -w16 -prw -fx -b0 -l0 -i$namebase.Adc$c"
#
#   set group [expr $c / 16]
#   set entry [expr  $c - [expr $group * 16]]
#   set address [lindex $VXMSKAddressTable $group]
#   gmt_register  Enable  xDig  "-s$slot -c0 -o$address -w16 -prw -fd -b$entry -l1"
#
#}

proc {GMT_DAQ-reset}  {args}  {
#    Ganil GMT module
  set module [first $args]
  write-vxi-register $module.VXCONTRL.MP 1
}

proc {GMT_DAQ-setup}  {args}  {
#    Ganil GMT module
  set module [first $args]

# GMT_MASK
	write-vxi-register $module.GMT.MASK 0x1ffff
# GMT_STAND
	write-vxi-register $module.GMT.STAND 0x0
# GMT_GATING
	write-vxi-register $module.GMT.GATING 0xffff
# GMT_TYPE
	write-vxi-register $module.GMT.TYPE 0x0
# GMT_WINFAG
	write-vxi-register $module.GMT.WINFLAG 20
# GMT_RELEASE
	write-vxi-register $module.GMT.RELEASE 0x1
# GMT_CODSET
	write-vxi-register $module.GMT.CODSET 0x1
# GMT_STATMRK
	write-vxi-register $module.GMT.STATMRK 0xe
}


proc {GMT_DAQ-go}  {args}  {
#    Ganil GMT module
  set module [first $args]
  write-vxi-register $module.VXCONTRL.MP 0
  write-vxi-register $module.VXCONTRL.ZP 1
}

proc {GMT_DAQ-halt}  {args}  {
#    Ganil GMT module
  set module [first $args]
  write-vxi-register $module.VXCONTRL.MP 1
}
