#   gocce.defn.tcl     ExoGam Outer Contact Card (GOCCE) VXI card


proc {AddGOCCEModule}  {module slot}  {
   global registerbase cardtype
   global file

   set registerbase $cardtype$module
   set file 0

   delete-vxi-registers $registerbase.*

   GOCCEVXIRegisters $slot
   GOCCEModuleRegisters  $slot
   
        set c 0
        foreach xtal {A B C D} {
            set registerbase $cardtype$module.Xtal$xtal
            GOCCEXtalRegisters $slot $c
            SETGOCCEGIRegisters  $slot $c 
            incr c
        }
}

proc {BuildGOCCEModule}  {}  {
   global file
   global registerbase

   set registerbase ""

   set f "gocce.defn.c"

   set z [catch {open $f w} file]
   if {$z != 0} then {return $file}

   GOCCEVXIRegisters %d
   GOCCEModuleRegisters %d
   
        set c 0
        foreach xtal {A B C D} {
            set registerbase Xtal$xtal
            GOCCEXtalRegisters %d $c
            incr c
        }
   
   close $file
   return 0
}

proc gocce_register {registername class attributes} {
   global registerbase
   global file

   if {$file == 0} {
       define-vxi-register $registerbase $class $registername "$attributes"
   } else {
       if {$registerbase == ""} then {
           puts $file "\{\"$registername\",   \"$class\",  \"$attributes\"\},"
       } else {
           puts $file "\{\"$registerbase.$registername\",   \"$class\",  \"$attributes\"\},"
       }
   }
}

proc GOCCEVXIRegisters {slot} {

   gocce_register  datal          xDig "-s$slot  -o0x0 -w32 -prw -fx"
   gocce_register  dataw          xDig "-s$slot  -o0x0 -w16 -prw -fx"

   gocce_register  VXI.ManID      xSht  "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   gocce_register  VXI.AddrSpace  xSht  "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   gocce_register  VXI.DevClass   xSht  "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   gocce_register  VXI.ModelCode  xSht  "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   gocce_register  VXI.ReqMem     xSht  "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   gocce_register  VXI.Reset      xSht  "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   gocce_register  VXI.Passed     xSht  "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   gocce_register  VXI.Ready      xSht  "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   gocce_register  VXI.ModID      xSht  "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   gocce_register  VXI.A24A32     xSht  "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   gocce_register  VXI.Offset     xSht  "-s$slot -o6  -pro -w16 -fx"
   gocce_register  VXI.SerialNum  xSht  "-s$slot -o8  -pro -w16 -fx"
   gocce_register  VXI.ModLevel   xSht  "-s$slot -o10 -pro -w16 -fx"
}


proc GOCCEModuleRegisters {slot} {
   global registerbase

#    GIR Module Control Register

    gocce_register   MCR_GIR          xDig    "-s$slot  -o0x10 -w16 -prw -fx -b0 -l0 -i0"
    gocce_register   LastCard         xDig    "-s$slot  -o0x10 -w16 -prw -fd -b0 -l1"
    gocce_register   FIFO.Reset       xDig    "-s$slot  -o0x10 -w16 -prw -fd -b1 -l1"
    gocce_register   DSP.Reset        xDig    "-s$slot  -o0x10 -w16 -prw -fd -b2 -l1"
    gocce_register   ResetGIR         xDig    "-s$slot  -o0x10 -w16 -prw -fd -b3 -l1"
    
    gocce_register   DSP.DAC.Adj      xDig    "-s$slot  -o0x14 -w16 -pwo -fx -b0 -l0"
    gocce_register   DSP.POT.Adj      xDig    "-s$slot  -o0x16 -w16 -pwo -fx -b0 -l0"
    
#   Temperature control registers  0x40 => 0x54

       gocce_register   GIR.TCR.ReadTemp         xDig    "-s$slot  -o0x40 -w16 -pro -fx -b0 -l9"
       gocce_register   GIR.TCR.WriteTempHigh    xDig    "-s$slot  -o0x42 -w16 -pwo -fx -b0 -l9 -i0x3c"
       gocce_register   GIR.TCR.WriteTempLow     xDig    "-s$slot  -o0x44 -w16 -pwo -fx -b0 -l9 -i0x38"
       gocce_register   GIR.TCR.ReadTempHigh     xDig    "-s$slot  -o0x46 -w16 -pro -fx -b0 -l9"
       gocce_register   GIR.TCR.ReadTempLow      xDig    "-s$slot  -o0x48 -w16 -pro -fx -b0 -l9"
       gocce_register   GIR.TCR.ReadCounter      xDig    "-s$slot  -o0x4A -w16 -pro -fx -b0 -l9"
       gocce_register   GIR.TCR.ReadSlope        xDig    "-s$slot  -o0x4C -w16 -pro -fx -b0 -l9"
       gocce_register   GIR.TCR.StartConvert     xDig    "-s$slot  -o0x4E -w16 -pwo -fx -b0 -l9"
       gocce_register   GIR.TCR.StopConvert      xDig    "-s$slot  -o0x50 -w16 -pwo -fx -b0 -l9"

        gocce_register   GIR.TCR.ClearAlarm    xDig    "-s$slot  -o0x52 -w16 -pwo -fx -b5 -l2"
        gocce_register   GIR.TCR.ReadConfig.Low   xDig    "-s$slot  -o0x54 -w16 -pro -fx -b5 -l1 "
        gocce_register   GIR.TCR.ReadConfig.High  xDig    "-s$slot  -o0x54 -w16 -pro -fx -b6 -l1 "
       
#    Analogue Card EEPROM is at 0x100 => 0x1fe

#       gocce_register EEPROM.ManID             xDig "-s$slot -o0x100 -w16 -pro -fx -b0 -l8"
#       gocce_register EEPROM.SerialNum         xDig "-s$slot -o0x108 -w16 -pro -fx -b0 -l8"
#       gocce_register EEPROM.ModLevel          xDig "-s$slot -o0x10a -w16 -pro -fx -b0 -l8"

#    GOCCE Digital Inspection Lines

    gocce_register   Insp.D1.Channel   xMux    "-s$slot  -o0x200 -w16 -prw -b0 -l16 -dGOCCE -md1"
    gocce_register   Insp.D1.Signal    xDig    "-s$slot  -o0x220 -w16 -prw -fd -b0 -l0 -i0"
    gocce_register   Insp.D2.Channel   xMux    "-s$slot  -o0x240 -w16 -prw -b0 -l16 -dGOCCE -md2"
    gocce_register   Insp.D2.Signal    xDig    "-s$slot  -o0x260 -w16 -prw -fd -b0 -l0 -i0"
    
#    GOCCE Analogue Inspection Lines

    gocce_register   Insp.A1.Channel   xMux    "-s$slot  -o0x280 -w16 -prw -b0 -l16 -dGOCCE -ma1"
    gocce_register   Insp.A1.Signal    xDig    "-s$slot  -o0x2a0 -w16 -prw -fd -b0 -l0 -i0"
    gocce_register   Insp.A2.Channel   xMux    "-s$slot  -o0x2c0 -w16 -prw -b0 -l16 -dGOCCE -ma2"
    gocce_register   Insp.A2.Signal    xDig    "-s$slot  -o0x2e0 -w16 -prw -fd -b0 -l0 -i0"

#    GIR registers      

    gocce_register   GIR.EvNum.Count         xDig  "-s$slot  -o0x300 -w16 -prw -fx -b0 -l0 -i0"
    gocce_register   GIR.EvNum.Addr          xAdr  "-s$slot  -c0 -o0x302 -w16 -b0 -l0"
    gocce_register   GIR.EvNum               xDig  "-s$slot  -o0x300 -w32 -pro -fx -b0 -l0"
    gocce_register   GIR.FIFO.Test           xFIT  "-s$slot  -o0x304 -w32 -prw -fx"
    
       gocce_register   GIR.DCR                     xDig  "-s$slot  -o0x308 -w16 -prw -fx -b0 -l0 -i0"

       gocce_register   GIR.DCR.DataXfer1.Enable    xDig    "-s$slot  -o0x308 -w16 -prw -fx -b0 -l1"
       gocce_register   GIR.DCR.DataXfer2.Enable    xDig    "-s$slot  -o0x308 -w16 -prw -fx -b1 -l1"
       gocce_register   GIR.DCR.DSP_Enable          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b2 -l1"
       gocce_register   GIR.DCR.DMA_TEST            xDig    "-s$slot  -o0x308 -w16 -prw -fx -b3 -l1"
       gocce_register   GIR.DCR.ADCSSE              xDig    "-s$slot  -o0x308 -w16 -prw -fx -b4 -l1"
       gocce_register   GIR.DCR.Process             xDig    "-s$slot  -o0x308 -w16 -prw -fx -b8 -l2"
       gocce_register   GIR.DCR.Spectre             xDig    "-s$slot  -o0x308 -w16 -prw -fx -b8 -l1"
       gocce_register   GIR.DCR.Scaler              xDig    "-s$slot  -o0x308 -w16 -prw -fx -b9 -l1"

       gocce_register   GIR.RCR                         xDig  "-s$slot  -o0x30a -w16 -prw -fx -b0 -l0"

       gocce_register   GIR.RCR.ValAck.TimeOutReset     xDig    "-s$slot  -o0x30a -w16 -prw -fx -b0 -l1 -i1"
       gocce_register   GIR.RCR.ReadOut.Disable         xDig    "-s$slot  -o0x30a -w16 -prw -fx -b1 -l1"
       gocce_register   GIR.RCR.EvNumData.Disable       xDig    "-s$slot  -o0x30a -w16 -prw -fx -b2 -l1"
       gocce_register   GIR.RCR.QStat                   xDig    "-s$slot  -o0x30a -w16 -prw -fx -b3 -l1"
       gocce_register   GIR.RCR.Pipeline.Enable         xDig    "-s$slot  -o0x30a -w16 -prw -fx -b4 -l1"
       gocce_register   GIR.RCR.CommonDeadtime.Enable   xDig    "-s$slot  -o0x30a -w16 -prw -fx -b5 -l1"
       gocce_register   GIR.RCR.ExtReadout.Enable       xDig    "-s$slot  -o0x30a -w16 -prw -fx -b6 -l1"

       gocce_register   GIR.ROTSR                       xDig    "-s$slot  -o0x30c -w16 -pro -fx -b0 -l0"

       gocce_register   GIR.ROTSR.Temp.Status.GIR       xDig    "-s$slot  -o0x30c -w16 -pro -fx -b0 -l2"
       gocce_register   GIR.ROTSR.Temp.Status1          xDig    "-s$slot  -o0x30c -w16 -pro -fx -b2 -l2"
       gocce_register   GIR.ROTSR.Temp.Status2          xDig    "-s$slot  -o0x30c -w16 -pro -fx -b4 -l2"
       gocce_register   GIR.ROTSR.ValAck.TimeOut.Status xDig    "-s$slot  -o0x30c -w16 -pro -fx -b6 -l1"
       gocce_register   GIR.ROTSR.FIFO.Status           xDig    "-s$slot  -o0x30c -w16 -pro -fx -b8 -l2"

    gocce_register   GIR.ValAck.TimeOut      xDAC  "-s$slot -c0 -a0 -z0 -o0x30e -w16 -prw -qn -us -d0 -r0:0s,0xffff:2048us -i75us"
    
#    Analogue card Memory Map   -  common area base =   0x0800 => 0x08fc

       gocce_register   PDSGate.Width     xDig "-s$slot -a0x0000 -o0x800 -w16 -prw -fd -l8 -i160"
       gocce_register   PDSGate.Delay     xDig "-s$slot -a0x0000 -o0x804 -w16 -prw -fd -l8 -i20"
       gocce_register   ValSample         xDig "-s$slot -a0x0000 -o0x808 -w16 -prw -fd -l8 -i65"
       gocce_register   WatchdogSample    xDig "-s$slot -a0x0000 -o0x80c -w16 -prw -fd -l0 -i150"
       gocce_register   CRC               xDig "-s$slot -a0x0000 -o0x810 -w16 -prw -fx -l0"
       gocce_register   SSCounter         xDig "-s$slot -a0x0000 -o0x824 -w16 -prw -fd -l0 -i0"
       gocce_register   SSPulse           xDig "-s$slot -a0x0000 -o0x828 -w16 -pwo"
       
       gocce_register   CRC.OpMode           xDig "-s$slot -a0x0000 -o0x810 -w16 -prw -fd -b0 -l1 -i0"
       gocce_register   CRC.TDCStop          xDig "-s$slot -a0x0000 -o0x810 -w16 -prw -fd -b1 -l1 -i0"
       gocce_register   CRC.ReadOutDisable   xDig "-s$slot -a0x0000 -o0x810 -w16 -prw -fd -b2 -l1 -i0"
       gocce_register   CRC.GOCCEStart       xDig "-s$slot -a0x0000 -o0x810 -w16 -prw -fd -b3 -l1 -i0"
       gocce_register   CRC.ScalerEnable     xDig "-s$slot -a0x0000 -o0x810 -w16 -prw -fd -b4 -l1 -i1"
       gocce_register   CRC.Veto             xDig "-s$slot -a0x0000 -o0x810 -w16 -prw -fd -b5 -l1"
       gocce_register   CRC.SSEnable         xDig "-s$slot -a0x0000 -o0x810 -w16 -prw -fd -b6 -l1 -i1"
       gocce_register   CRC.SSMode           xDig "-s$slot -a0x0000 -o0x810 -w16 -prw -fd -b7 -l1"
       gocce_register   CRC.GOCCEInhReqMode  xDig "-s$slot -a0x0000 -o0x810 -w16 -prw -fd -b8 -l1"
       gocce_register   CRC.GOCCEScalersMode xDig "-s$slot -a0x0000 -o0x810 -w16 -prw -fd -b9 -l1"
       gocce_register   CRC.ResetScalers     xDig "-s$slot -a0x0000 -o0x810 -w16 -prw -fd -b10 -l1"
       gocce_register   CRC.DspSSCalibrateEn xDig "-s$slot -a0x0000 -o0x810 -w16 -prw -fd -b11 -l1"

#    GIR DSP Registers

    gocce_register   GIR.DSP.ExtMem        bVXI    "-s$slot  -a0x200000 -o0x0 -w32 -pro -fx -l64"
    gocce_register   GIR.DSP.IntMem        bVXI    "-s$slot  -a0x400000 -o0x0 -w32 -pro -fx -l64"
    gocce_register   GIR.DSP.SpectrumData  bVXI    "-s$slot  -a0x200000 -o0x0 -w32 -pro -fx -l64"
    gocce_register   GIR.DSP.Program       xGIR    "-s$slot  -a0x400010 -l8192 -v4 -m0 -i/MIDAS/vxi/tcl/gir/DspLdr/5/GOCCE.ldr"

        gocce_register GIR.DSP.Control              xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fx -b0 -l0"
    
        gocce_register GIR.DSP.StartDSP             xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b0 -l1"
        gocce_register GIR.DSP.FilterMode           xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b1 -l1"
        gocce_register GIR.DSP.Bit2                 xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b2 -l1"
        gocce_register GIR.DSP.DSPtotcount                 xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b3 -l1"
        gocce_register GIR.DSP.ResetDSP             xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b4 -l1" 
        gocce_register GIR.DSP.Muxalim                 xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b5 -l1"
        gocce_register GIR.DSP.PZ                   xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b6 -l1"
        gocce_register GIR.DSP.ResetMemExt          xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b7 -l1"
        
        gocce_register GIR.DSP.Process              xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b8 -l4"
        gocce_register GIR.DSP.Spectre              xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b8 -l1"
        gocce_register GIR.DSP.Scaler               xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b9 -l1"
        gocce_register GIR.DSP.SSCalibrateEn                xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b10 -l1"
        gocce_register GIR.DSP.Bit11                xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b11 -l1" 
        gocce_register GIR.DSP.Bit12                xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b12 -l1"
        gocce_register GIR.DSP.Bit13                xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b13 -l1"
        gocce_register GIR.DSP.Bit14                xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b14 -l1"
        gocce_register GIR.DSP.Bit15                xDig "-s$slot -a0x400000 -o0xbff40 -w32 -prw -fd -b15 -l1"
        
 	gocce_register   GIR.DSP.Syscon       xDig    "-s$slot  -a0x400000 -o0x0 -w32 -prw -fd -b0 -l0 "
	gocce_register   GIR.DSP.Wait         xDig    "-s$slot  -a0x400000 -o0x8 -w32 -prw -fd -b12 -l3 "


	gocce_register   GIR.DSP.DMAC7        xDig    "-s$slot  -a0x400000 -o0x74   -w32 -prw -fx -b0 -l0 "
	gocce_register   GIR.DSP.C7           xDig    "-s$slot  -a0x400000 -o0x128  -w32 -prw -fx -b0 -l0 "
	gocce_register   GIR.DSP.EC7          xDig    "-s$slot  -a0x400000 -o0x13c  -w32 -prw -fx -b0 -l0 "
	gocce_register   GIR.DSP.LCTL         xDig    "-s$slot  -a0x400000 -o0x318  -w32 -prw -fx -b0 -l0 "
	gocce_register   GIR.DSP.LCOM         xDig    "-s$slot  -a0x400000 -o0x31c  -w32 -prw -fx -b0 -l0 "
	gocce_register   GIR.DSP.Reg0         xDig    "-s$slot  -a0x400000 -o0x98000 -w32 -prw -fd -b0 -l0 "
	gocce_register   GIR.DSP.Item         xDig    "-s$slot  -a0x400000 -o0x98004 -w32 -prw -fx -b0 -l0"
	gocce_register   GIR.DSP.Reg2         xDig    "-s$slot  -a0x400000 -o0x98008 -w32 -prw -fd -b0 -l0 "
	gocce_register   GIR.DSP.Reg3         xDig    "-s$slot  -a0x400000 -o0x9800C -w32 -prw -fd -b0 -l0 "
	gocce_register   GIR.DSP.Reg4         xDig    "-s$slot  -a0x400000 -o0x98010 -w32 -prw -fd -b0 -l0 "
	gocce_register   GIR.DSP.Reg5         xDig    "-s$slot  -a0x400000 -o0x98014 -w32 -prw -fd -b0 -l0 "
	gocce_register   GIR.DSP.Reg6         xDig    "-s$slot  -a0x400000 -o0x98018 -w32 -prw -fd -b0 -l0 -i8000 "
	gocce_register   GIR.DSP.DeltaPZ      xDig    "-s$slot  -a0x400000 -o0x9801C -w32 -prw -fd -b0 -l0 "
	gocce_register   GIR.DSP.inmux        xDig    "-s$slot  -a0x400000 -o0x98080 -w32 -prw -fd -b0 -l0 "
	gocce_register   GIR.DSP.PosBit       xDig    "-s$slot  -a0x400000 -o0x98084 -w32 -prw -fd -b0 -l6 "
	gocce_register   GIR.DSP.NbBit        xDig    "-s$slot  -a0x400000 -o0x98084 -w32 -prw -fd -b6 -l6 "

}

proc GOCCEXtalRegisters {slot c} {
   global file
   
#    scaler area 

    gocce_register Seg0.Scaler      xDig    "-s$slot -c$c -z0x10 -a0x0840 -o0x0 -w32 -pro -fd"
    gocce_register Seg1.Scaler      xDig    "-s$slot -c$c -z0x10 -a0x0840 -o0x4 -w32 -pro -fd"
    gocce_register Seg2.Scaler      xDig    "-s$slot -c$c -z0x10 -a0x0840 -o0x8 -w32 -pro -fd"
    gocce_register Seg3.Scaler      xDig    "-s$slot -c$c -z0x10 -a0x0840 -o0xc -w32 -pro -fd"

    if {$file != 0} {
#       item/group setup 

#    item/group setup 2 b used when the register base is in the VXI.o

    gocce_register Seg0.Energy.Addr      xAdr    "-s$slot -c$c -z0x1000 -a0x1000 -o0x00 -w32"
    gocce_register Seg1.Energy.Addr      xAdr    "-s$slot -c$c -z0x1000 -a0x1000 -o0x04 -w32"
    gocce_register Seg2.Energy.Addr      xAdr    "-s$slot -c$c -z0x1000 -a0x1000 -o0x08 -w32"
    gocce_register Seg3.Energy.Addr      xAdr    "-s$slot -c$c -z0x1000 -a0x1000 -o0x0c -w32"

    gocce_register Seg0.Time.Addr      xAdr    "-s$slot -c$c -z0x1000 -a0x1000 -o0x10 -w32"
    gocce_register Seg1.Time.Addr      xAdr    "-s$slot -c$c -z0x1000 -a0x1000 -o0x14 -w32"
    gocce_register Seg2.Time.Addr      xAdr    "-s$slot -c$c -z0x1000 -a0x1000 -o0x18 -w32"
    gocce_register Seg3.Time.Addr      xAdr    "-s$slot -c$c -z0x1000 -a0x1000 -o0x1c -w32"
    }

    gocce_register FTSample      xDig    "-s$slot -c$c -z0x1000 -a0x1040 -o0x0 -w16 -prw -fd -b0 -l8 -i24"
    gocce_register RCR           xDig    "-s$slot -c$c -z0x1000 -a0x1048 -o0x0 -w16 -prw -fd -b0 -l0"
  
#    set up DTD enable register 

    gocce_register Seg0.Enable  xDig    "-s$slot -c$c -z0x1000 -a0x1044 -o0x0 -w16 -prw -fd -b0 -l1 -i0"
    gocce_register Seg1.Enable  xDig    "-s$slot -c$c -z0x1000 -a0x1044 -o0x0 -w16 -prw -fd -b1 -l1 -i0"
    gocce_register Seg2.Enable  xDig    "-s$slot -c$c -z0x1000 -a0x1044 -o0x0 -w16 -prw -fd -b2 -l1 -i0"
    gocce_register Seg3.Enable  xDig    "-s$slot -c$c -z0x1000 -a0x1044 -o0x0 -w16 -prw -fd -b3 -l1 -i0"

#    set up DTD Thresholds  

        gocce_register   DTD.Thresh0	xDig "-s$slot -c$c -z0x1000 -a0x1050 -o0x0 -w32 -pwo -fx -b0 -l8 -i16"
        gocce_register   DTD.Thresh1	xDig "-s$slot -c$c -z0x1000 -a0x1050 -o0x4 -w32 -pwo -fx -b0 -l8 -i16"
        gocce_register   DTD.Thresh2	xDig "-s$slot -c$c -z0x1000 -a0x1050 -o0x8 -w32 -pwo -fx -b0 -l8 -i16"
        gocce_register   DTD.Thresh3	xDig "-s$slot -c$c -z0x1000 -a0x1050 -o0xC -w32 -pwo -fx -b0 -l8 -i16"


#    readout enable register 


    gocce_register Seg0.Energy.ROEnable  xDig    "-s$slot -c$c -z0x1000 -a0x1040 -o0x8 -w16 -prw -fd -b0 -l1"
    gocce_register Seg1.Energy.ROEnable  xDig    "-s$slot -c$c -z0x1000 -a0x1040 -o0x8 -w16 -prw -fd -b1 -l1"
    gocce_register Seg2.Energy.ROEnable  xDig    "-s$slot -c$c -z0x1000 -a0x1040 -o0x8 -w16 -prw -fd -b2 -l1"
    gocce_register Seg3.Energy.ROEnable  xDig    "-s$slot -c$c -z0x1000 -a0x1040 -o0x8 -w16 -prw -fd -b3 -l1"
    
    gocce_register Seg0.Time.ROEnable    xDig    "-s$slot -c$c -z0x1000 -a0x1040 -o0x8 -w16 -prw -fd -b4 -l1"
    gocce_register Seg1.Time.ROEnable    xDig    "-s$slot -c$c -z0x1000 -a0x1040 -o0x8 -w16 -prw -fd -b5 -l1"
    gocce_register Seg2.Time.ROEnable    xDig    "-s$slot -c$c -z0x1000 -a0x1040 -o0x8 -w16 -prw -fd -b6 -l1"
    gocce_register Seg3.Time.ROEnable    xDig    "-s$slot -c$c -z0x1000 -a0x1040 -o0x8 -w16 -prw -fd -b7 -l1"
    
    gocce_register LT.Enable             xDig    "-s$slot -c$c -z0x1000 -a0x1040 -o0x8 -w16 -prw -fx -b11 -l1-i1"
    gocce_register TAC.Enable            xDig    "-s$slot -c$c -z0x1000 -a0x1040 -o0x8 -w16 -prw -fx -b12 -l1 -i1"
    gocce_register CRCR.Spare.En	xDig     "-s$slot -c$c -z0x1000 -a0x1040 -o0x8 -w16 -prw -fx -b8 -l1 -i0"
    gocce_register CRCR.Spare.Setup	xDig     "-s$slot -c$c -z0x1000 -a0x1040 -o0x8 -w16 -prw -fx -b9 -l2"


#    SPACE Area

#    gocce_register   SPACE.ExtMem        bVXI    "-s$slot -c$c -z0x800000  -a0x1000000 -o0x000000 -w32 -pro -fx -l64"
#    gocce_register   SPACE.DSP1          bVXI    "-s$slot -c$c -z0x800000  -a0x1000000 -o0x200000 -w32 -pro -fx -l64"
#    gocce_register   SPACE.DSP2          bVXI    "-s$slot -c$c -z0x800000  -a0x1000000 -o0x400000 -w32 -pro -fx -l64"
#    gocce_register   SPACE.DSP3          bVXI    "-s$slot -c$c -z0x800000  -a0x1000000 -o0x600000 -w32 -pro -fx -l64"
}

proc SETGOCCEGIRegisters {slot c} {

# WRITE GROUP ITEM CHANNEL REGISTERS

#    RGI Area write mode

# j : increment de 0 a 3 et numero de segment
# i : offset
# l : item initial, avec group = 175 0xaf pour la position des bits dans le GI word
 

for {set j 0} {$j<4} {incr j} {
set i [expr $j*4]
set l [expr $j*0x100+ 0x800*$c+0xaf]

    gocce_register Seg$j.Energy.Addr      xAdr    "-s$slot -c$c -z0x1000 -a0x1000 -o$i -w32 -i$l"

				}


for {set j 0} {$j<4} {incr j} {
set i [expr ($j)*4+0x10]
set l [expr ($j+4)*0x100+0x800*$c+0xaf]

    gocce_register Seg$j.Time.Addr      xAdr    "-s$slot -c$c -z0x1000 -a0x1000 -o$i -w32 -i$l"

				}

}

proc GOCCE_DAQ-setup   {args}   {
   set module [first $args]

#    flush FIFOs
   write-vxi-register $module.FIFO.Reset 0
   write-vxi-register $module.FIFO.Reset 1
   write-vxi-register $module.FIFO.Reset 0

#    load DSP program  (default)
    write-vxi-register $module.DSP.Reset 1
    write-vxi-register $module.DSP.Reset 0

    modify-vxi-register $module.GIR.DSP.Program "-m 2"
    write-vxi-register  $module.GIR.DSP.Program ""
    modify-vxi-register $module.GIR.DSP.Program "-m 0"

#Perform Sliding scale reset for TEST SALTI

 set ssenablestatus($module) [read-vxi-register $module.CRC.SSEnable ]
 set ssminmaxstatus($module) [read-vxi-register $module.CRC.SSMode ]
write-vxi-register $module.CRC.SSEnable 0	
write-vxi-register $module.CRC.SSMode 0	
write-vxi-register $module.CRC.SSMode 1	
write-vxi-register $module.CRC.SSMode 0	
write-vxi-register $module.CRC.SSMode 1	
write-vxi-register $module.CRC.SSMode 0	

write-vxi-register $module.CRC.SSEnable $ssenablestatus($module)
write-vxi-register $module.CRC.SSMode $ssminmaxstatus($module)

    insert-log "Program [read-vxi-register  $module.GIR.DSP.Program] loaded into GIR DSP in $module"

  write-vxi-register $module.GIR.DCR.DataXfer2.Enable 1
  write-vxi-register $module.CRC.SSEnable 1
  write-vxi-register $module.GIR.RCR.EvNumData.Disable 1

    insert-log "Initialised registers for $module"

#    perform SS calibration

  set-footer "Starting $module Sliding Scale Calibration"
   GOCCE-sscalibrate $module
  insert-log "$module Sliding Scale Calibration completed"

  clear-footer
}


proc GOCCE_DAQ-reset   {args}   {
   set module [first $args]
#    flush FIFOs
   write-vxi-register $module.FIFO.Reset 0
   write-vxi-register $module.FIFO.Reset 1
   write-vxi-register $module.FIFO.Reset 0
#    reset and enable GIR
   write-vxi-register $module.GIR.FIFO.Test 0
   read-vxi-register $module.GIR.FIFO.Test

# reset DSP GIR
   write-vxi-register $module.GIR.DSP.StartDSP 0
   write-vxi-register $module.GIR.DSP.ResetDSP 1

#Perform Sliding scale reset for TEST SALTI

 set ssenablestatus($module) [read-vxi-register $module.CRC.SSEnable ]
 set ssminmaxstatus($module) [read-vxi-register $module.CRC.SSMode ]
write-vxi-register $module.CRC.SSEnable 0	
write-vxi-register $module.CRC.SSMode 0	
write-vxi-register $module.CRC.SSMode 1	
write-vxi-register $module.CRC.SSMode 0	
write-vxi-register $module.CRC.SSMode 1	
write-vxi-register $module.CRC.SSMode 0	

write-vxi-register $module.CRC.SSEnable $ssenablestatus($module)
write-vxi-register $module.CRC.SSMode $ssminmaxstatus($module)

}


proc GOCCE_DAQ-halt   {args}   {
   set module [first $args]
# stop DSP GIR
   write-vxi-register $module.GIR.DSP.StartDSP 0

}


proc GOCCE_DAQ-go   {args}   {
   set module [first $args]
#    zero event numbers
   write-vxi-register $module.GIR.EvNum.Count 0

#    ensure GIR event number readout OFF  - its doesn't work
   write-vxi-register $module.GIR.RCR.EvNumData.Disable 1

#    Init DAQ with GIR DSP

write-vxi-register $module.GIR.DCR.DSP_Enable 1
write-vxi-register $module.GIR.DCR.DataXfer1.Enable 1
set filter [read-vxi-register $module.GIR.DCR.DataXfer2.Enable]

#  SET ITEM = 0 FOR GOCCE BGA DSP SPECTRA 

set data3 [read-vxi-register $module.XtalA.Seg0.Energy.Addr]
write-vxi-register $module.GIR.DSP.Item $data3

 set spectraflag($module) [read-vxi-register $module.GIR.DCR.Process]
 
 write-vxi-register $module.GIR.DSP.Process $spectraflag($module)

#    start the GIR DSP
  write-vxi-register $module.GIR.DSP.FilterMode $filter
  write-vxi-register $module.GIR.DSP.StartDSP 1

}


proc GOCCE-sscalibrate {module} {

# This step is needed to prepare the DSP before any calibration is made.
# The DSP  program step must be in the main menu waiting for an order.
# this means that we must stop the DSP before the sliding scale calibration.
# SAVE THE DSP Control register @0x2ffd0, or 0x dsp+0xbff40 in VME space

 set DSPCONTROLSTATUS [read-vxi-register $module.GIR.DSP.Control]

 write-vxi-register $module.GIR.DSP.Control 0
 after 10

# We must reset all the current variables and counts inside the DSP program first.
# wait 100 ms for the RESET procedure to finish before reinitialise the DSP.

 write-vxi-register $module.GIR.DSP.ResetDSP 1
 after 15

# We need to initialise the item0 which is needed to store the ADC calibration parameters.

 set data3 [read-vxi-register $module.XtalA.Seg0.Energy.Addr]
 write-vxi-register $module.GIR.DSP.Item $data3

# Read the necessary status of all the registers that need to be modified for the 
# sliding scale correction before modifying them
# so that we can go back to the old status of the card.
# In this way there will be no residues from the SS calibration effect on the card.

 set CRCSTATUS [read-vxi-register $module.CRC] 
 set rcrA [read-vxi-register $module.XtalA.RCR] 
 set rcrB [read-vxi-register $module.XtalB.RCR] 
 set rcrC [read-vxi-register $module.XtalC.RCR] 
 set rcrD [read-vxi-register $module.XtalD.RCR] 
 set DCRSTATUS [read-vxi-register $module.GIR.DCR]
 
# We need to enable all the energy parameters for the sliding scale calculations.

 write-vxi-register $module.XtalA.RCR 0x180f 
 write-vxi-register $module.XtalB.RCR 0x180f 
 write-vxi-register $module.XtalC.RCR 0x180f
 write-vxi-register $module.XtalD.RCR 0x180f 

# This step is very essential to get rid of the current sliding scale value at the dac output.

 write-vxi-register $module.CRC.SSEnable 0	
 write-vxi-register $module.CRC.SSMode 0	
 write-vxi-register $module.CRC.SSMode 1	
 write-vxi-register $module.CRC.SSMode 0	

# We must reset the Common Register Control and the DCR

write-vxi-register $module.CRC 0x0 
write-vxi-register $module.GIR.DCR 0x0 

# Enable  the GIR DCR Sliding Scale calibration.

write-vxi-register $module.GIR.DCR.ADCSSE 1

# Enable  the DSP  Sliding Scale calibration Register.

write-vxi-register $module.GIR.DSP.SSCalibrateEn 1

# Enable  the GOCCE Sliding Scale calibration.

write-vxi-register $module.CRC.DspSSCalibrateEn 1

#Configure the DSP acquisition as normal DAQ run without filter mode.

write-vxi-register $module.GIR.DCR.DSP_Enable 1
write-vxi-register $module.GIR.DCR.DataXfer1.Enable 1
write-vxi-register $module.GIR.DCR.DataXfer2.Enable 0

#    start the GIR DSP Sliding Scale calibration.

  write-vxi-register $module.GIR.DSP.FilterMode 0
  write-vxi-register $module.GIR.DSP.StartDSP 1

# It is extremely important to keep 1 second after the DSP start so that the calibration can take place before returning 
# the parameters to their initial values.

after 1500

# returning the parameters to their initial values.

   write-vxi-register $module.GIR.DSP.StartDSP 0

#    flush FIFOs to reset adc_coding-deadtime but you need to disable dma2dsp flag because
# a start readout is generated when you reset the FIFO

write-vxi-register $module.GIR.DCR.DataXfer1.Enable 0

   write-vxi-register $module.FIFO.Reset 0
   write-vxi-register $module.FIFO.Reset 1
   write-vxi-register $module.FIFO.Reset 0

   write-vxi-register $module.GIR.DSP.ResetMemExt 1

after 550

   write-vxi-register $module.GIR.DCR.ADCSSE 0
   write-vxi-register $module.CRC.DspSSCalibrateEn 0
   write-vxi-register $module.GIR.DSP.SSCalibrateEn 0

 write-vxi-register $module.XtalA.RCR $rcrA 
 write-vxi-register $module.XtalB.RCR $rcrB 
 write-vxi-register $module.XtalC.RCR $rcrC 
 write-vxi-register $module.XtalD.RCR $rcrD 
 write-vxi-register $module.CRC $CRCSTATUS
 write-vxi-register $module.GIR.DCR $DCRSTATUS
 write-vxi-register $module.GIR.DSP.Control $DSPCONTROLSTATUS

}


