#    hist task code overlay for detector type "saphir"


set lowchannel  0
set highchannel 48
set maxchannel  64

set saphirnames   {Energy Timing}
set qnames   {q0 q1 q2 q3}
set qualnames {0 1 2 3}

set girnames      {GIR.EvNum}

set saphir 0
set gir 0


proc make-overlaypanel {} {
   global saphirnames girnames qnames

      :layout V; :row-gap 10; :col-gap 20

      :message DET-M1   :label "Saphir overlay applied"

      :number DET-LOW  :label "Low channel:"  :w 5 :valuex 15c
      :number DET-HIGH :label "High channel:" :w 5 :valuex 15c

      :choice DET-QUAL     :label "Qualifier" :valuex 15c  :exclusive F :strings $qnames       :value 1
      :choice DET-SAPHIR   :label "Items"     :valuex 15c  :exclusive F :strings $saphirnames  :value 0
      :choice DET-GIR      :label "GIR"       :valuex 15c  :exclusive F :strings $girnames     :value 0
}



#    this proc handles events from widgets created in the proc make-overlaypanel
#    The widgets DET-LOW; DET-HIGH and DET-QUAL are handled in the main click procedure
#    and are not required here

proc click-overlay {w v} {

   switch -glob $w {
      DET-SAPHIR     {click-adc $v saphir}
      DET-GIR        {click-adc $v gir}
      default      {puts stdout $arg}
   }
}

proc repaint_overlay {} {
   global spectrumlist
   global saphir gir

   if {[llength $spectrumlist] > 0} then {
       :modify DET-SAPHIR   :value 0
       :modify DET-GIR      :value 0
   } else {
       :modify DET-SAPHIR   :value $saphir
       :modify DET-GIR      :value $gir
   }
}


proc get-spectrum-list {} {
        global spectrumlist
        global saphirnames saphir girnames gir
        global qualifier qualnames
        global lowchannel highchannel

        if {$spectrumlist != {}} then {return $spectrumlist};  # return names selected from spectrum list

        set qlist [list-take $qualnames [bits-in $qualifier]]
        set list {}

# append  spectrum names
        for {set i $lowchannel} {$i<=$highchannel} {incr i} {
            foreach adc [list-take $saphirnames  [bits-in $saphir]]  {
                foreach q $qlist {
                   lappend list Saphir$i.$adc.q$q
                }
            }
            foreach adc [list-take $girnames     [bits-in $gir]]     {lappend list Saphir$i.$adc}
        }
        return $list
}

proc range-of n {

    set fields [split $n "."]
    switch -glob [second $fields]  {
        GIR       {return 0x10000}
        default   {return 8192}
    }
}
