#    hist task code overlay for detector type "trigger"


set lowchannel 0
set highchannel 0
set maxchannel 0

set trignames  {RwGe ClGe BGO User FTVal TAC EvNum}

set trig 0


proc make-overlaypanel {} {
   global trignames qnames

      :layout V; :row-gap 10; :col-gap 0

      :message DET-M1   :label "Trigger detector overlay applied"
      :hskip 100
      :choice DET-TRIG  :label "Items"   :exclusive F :strings $trignames :value 0 :layout V :w 10
}



#    this proc handles events from widgets created in the proc make-overlaypanel
#    The widgets DET-LOW; DET-HIGH and DET-QUAL are handled in the main click procedure
#    and are not required here

proc click-overlay {w v} {

   switch -glob $w {
      DET-TRIG           {click-adc $v trig}
      default      {puts stdout $arg}
   }
}

proc repaint_overlay {} {
   global spectrumlist
   global trig

   if {[llength $spectrumlist] > 0} then {
       :modify DET-TRIG  :value 0
   } else {
       :modify DET-TRIG  :value $trig
   }
}


proc get-spectrum-list {} {
        global spectrumlist
        global trignames trig

        if {$spectrumlist != {}} then {return $spectrumlist};  # return names selected from spectrum list

        set list {}

# append trig spectrum names
        foreach adc [list-take $trignames [bits-in $trig]] {lappend list Trig.$adc}
        return $list
}

proc range-of n {

    set fields [split $n "."]
    switch [second $fields]  {
        EvNum   {return 0x10000}
        TAC     {return 0x1000}
        default {return 0x100}
    }
}
