#    definitions used by the Clover VXI setup tasks
#


set chanlist {???}
set chanindex 0
set seglist {A B C D E}
set segindex 0

set defaultchanlist {0 1 2 3 4 5 6 7}

set cardtype Clover
set chantype Ge
set VXIGlobal Ge


#    The array "table" which is indexed by the "widget name" contains all the information needed
#    for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for register access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"


set table(ALLCHANS) {allchans int-widget->param param->int-widget nil nil nil nil nil nil nil nil 0 nil}
set table(ALLSEGS)  {allsegs  int-widget->param param->int-widget nil nil nil nil nil nil nil nil 0 nil}
set table(ENABLE) {enable int-widget->param param->int-widget "Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Enable"}

set table(MARKREJECT) {markreject int-widget->param param->int-widget "PileupReject"
       int-reg->param param->int-reg nil :choice Mark Reject nil 1 "Pileup"}

set CFDTHRESHLOW {cfdthresh slider-widget->param param->int-widget "CFD.Thresh"
       unit-reg->param param->unit-reg keV :slider 0 2600 1 1 "CFD Threshold (keV)"}
set CFDTHRESHHIGH {cfdthresh slider-widget->param param->int-widget "CFD.Thresh"
       unit-reg->param param->unit-reg keV :slider 0 825 1 1 "CFD Threshold (keV)"}
set table(CFDTHRESH) $CFDTHRESHHIGH

set table(CFDDELAY) {cfddelay slider-widget->param param->int-widget "CFD.Delay"
       unit-reg->param param->unit-reg ns :slider 0 200 1 1 "CFD Delay (ns)"}
set table(CFDWIDTH) {cfdwidth slider-widget->param param->int-widget "CFD.Width"
       unit-reg->param param->unit-reg ns :slider 0 200 1 1 "CFD Width (ns)"}
set table(POLEZERO) {polezero slider-widget->param param->int-widget "PoleZero"
       int-reg->param param->int-reg nil :slider 0 255 1 1 "Pole Zero"}

set table(FTSAMPLE) { ftsample slider-widget->param param->int-widget "FTSample"
       unit-reg->param param->unit-reg ns :slider 0 2000 8 1 "Fast Trigger Sample (ns)"}
set table(VALSAMPLE) {valsample slider-widget->param param->int-widget "ValSample"
       unit-reg->param param->unit-reg ns :slider 0 10000 40 1 "Validation Sample (ns)"}
set table(WATCHDOG) {watchdog slider-widget->param param->int-widget "Watchdog"
       unit-reg->param param->unit-reg ns :slider 0 16000 63 1 "LT Watchdog Timeout (ns)"}
set table(PDSGATE) {pdsgate slider-widget->param param->int-widget "PDSGate"
       unit-reg->param param->unit-reg ns :slider 0 10000 40 1 "PDS Gate (ns)"}

set table(READOUT20) {readout20 int-widget->param param->int-widget "20MeV.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "20 MeV ADC"}
set table(READOUT4) {readout4 int-widget->param param->int-widget "4MeV.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "4 MeV ADC"}
set table(READOUTFT) {readoutft int-widget->param param->int-widget "FT.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "FT TAC"}
set table(READOUTCO) {readoutco int-widget->param param->int-widget "CO.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "CO TAC"}


#    Inspection line configuration  -  this format is ONLY for Eurogam modules

set AI-Configuration [list Disconnected                            \
	4MeV-Unipolar 20MeV-Unipolar Pole-Zero                     \
	4MeV-PDS TFA-Input TFA-Output 4MeV-Bipolar FT-TAC-Output   \
]

set DI-Configuration [list Disconnected                            \
	CFD-Direct CFD-Delay FT-Pulse FT-Sample                    \
        Val-Pulse Val-Sample Pileup PDS-Gate LT-Reset              \
]


set readoutitems {READOUT20 READOUT4 READOUTFT READOUTCO}

set channelitems {MARKREJECT CFDWIDTH FTSAMPLE VALSAMPLE}

set segmentitems {ENABLE CFDTHRESH CFDDELAY POLEZERO PDSGATE}




set info(CARD) " From this window you can setup the electronics for the Ge part of the Eurogam Clover detector VXI electronics.\n\
                Each VXI card contains 5 Ge electronics channels. 4 are connected to the segments of the Clover detector.\n\
                The 5th channel is available as a spare."


